import { TrackingTag } from '../interfaces/i_tracking_tag';
import { nodeApiInfo as i } from '../interfaces/i_node_api_info';
export declare class NodeBackApi {
    readonly rootTag = "root";
    readonly onDataReceivedListeners: Set<i.onDataReceived.listener.FunctionType>;
    readonly onEventReceivedListeners: Set<i.onEventReceived.listener.FunctionType>;
    constructor();
    sendData(data: any, args?: {
        toTags?: TrackingTag[];
        channel?: string;
    }): Promise<void>;
    onDataReceived(listener: i.onDataReceived.ListenerType): Promise<void>;
    unsetOnDataReceived(listener?: i.onDataReceived.ListenerType): Promise<void>;
    sendEvent(event: string, args?: {
        toTags?: TrackingTag[];
        channel?: string;
        data?: any;
    }): Promise<void>;
    onEventReceived(listener: i.onEventReceived.ListenerType): Promise<void>;
    unsetOnEventReceived(listener?: i.onEventReceived.ListenerType): Promise<void>;
}
