export class ApiPreloadListenersController {
    _preloadlisteners = new Map();
    addPreloadListener(preloadListener, args) {
        const channelListeners = (() => {
            if (!this._preloadlisteners.has(args.channel)) {
                this._preloadlisteners.set(args.channel, new Map());
            }
            return this._preloadlisteners.get(args.channel);
        })();
        if (channelListeners.has(args.listenerId)) {
            throw new Error(`Preload Listener with the key "${args.listenerId}" already exists for the channel "${args.channel}"`);
        }
        channelListeners.set(args.listenerId, preloadListener);
    }
    removePreloadListener(args) {
        const channelListeners = this._preloadlisteners.get(args.channel);
        if (channelListeners === undefined) {
            throw new Error(`Preload Listeners storage for channel "${args.channel}" doesn't exist`);
        }
        const preloadListener = channelListeners.get(args.listenerId);
        if (preloadListener === undefined) {
            throw new Error(`Preload Listener with the key "${args.listenerId}" doesn't exist for the channel "${args.channel}"`);
        }
        channelListeners.delete(args.listenerId);
        return preloadListener;
    }
    removeAllPreloadListeners(args) {
        const channelListeners = this._preloadlisteners.get(args.channel);
        if (channelListeners === undefined) {
            throw new Error(`Preload Listeners storage for channel "${args.channel}" doesn't exist`);
        }
        channelListeners.clear();
    }
}
