import { PreloadApiBase } from '../classes/preload_api_base';
import { controlPanelApiInfoPreload as i } from '../interfaces/i_control_panel_api_info_preload';
export class ControlPanelPreloadApi extends PreloadApiBase {
    constructor(ipcRenderer) {
        super(ipcRenderer);
    }
    onGetInitialTabs = async (listener) => {
        this._addListener(listener, { channel: i.onGetInitialTabs.channel });
    };
    setTabs = async (...args) => {
        return this._sendRequestPromise(i.setTabs.channel, ...args);
    };
    onTabsSet = async (listener, extraArgs) => {
        this._addListener(listener, { ...extraArgs, channel: i.onTabsSet.channel });
    };
    unsetOnTabsSet = async (listenerId) => {
        this._removeListener({
            channel: i.onTabsSet.channel,
            listenerId: listenerId,
        });
    };
    setTabSections = async (...args) => {
        return this._sendRequestPromise(i.setTabSections.channel, ...args);
    };
    onTabSectionsSet = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabSectionsSet.channel,
        });
    };
    unsetOnTabSectionsSet = async (listenerId) => {
        this._removeListener({
            channel: i.onTabSectionsSet.channel,
            listenerId: listenerId,
        });
    };
    setTabButtons = async (...args) => {
        return this._sendRequestPromise(i.setTabButtons.channel, ...args);
    };
    onTabButtonsSet = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabButtonsSet.channel,
        });
    };
    unsetOnTabButtonsSet = async (listenerId) => {
        this._removeListener({
            channel: i.onTabButtonsSet.channel,
            listenerId: listenerId,
        });
    };
    setTabButtonItems = async (...args) => {
        return this._sendRequestPromise(i.setTabButtonItems.channel, ...args);
    };
    onTabButtonItemsSet = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabButtonItemsSet.channel,
        });
    };
    unsetOnTabButtonItemsSet = async (listenerId) => {
        this._removeListener({
            channel: i.onTabButtonItemsSet.channel,
            listenerId: listenerId,
        });
    };
    addTabs = async (...args) => {
        return this._sendRequestPromise(i.addTabs.channel, ...args);
    };
    onTabsAdded = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabsAdded.channel,
        });
    };
    unsetOnTabsAdded = async (listenerId) => {
        this._removeListener({
            channel: i.onTabsAdded.channel,
            listenerId: listenerId,
        });
    };
    addTabSections = async (...args) => {
        return this._sendRequestPromise(i.addTabSections.channel, ...args);
    };
    onTabSectionsAdded = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabSectionsAdded.channel,
        });
    };
    unsetOnTabSectionsAdded = async (listenerId) => {
        this._removeListener({
            channel: i.onTabSectionsAdded.channel,
            listenerId: listenerId,
        });
    };
    addTabButtons = async (...args) => {
        return this._sendRequestPromise(i.addTabButtons.channel, ...args);
    };
    onTabButtonsAdded = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabButtonsAdded.channel,
        });
    };
    unsetOnTabButtonsAdded = async (listenerId) => {
        this._removeListener({
            channel: i.onTabButtonsAdded.channel,
            listenerId: listenerId,
        });
    };
    addTabButtonItems = async (...args) => {
        return this._sendRequestPromise(i.addTabButtonItems.channel, ...args);
    };
    onTabButtonItemsAdded = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabButtonItemsAdded.channel,
        });
    };
    unsetOnTabButtonItemsAdded = async (listenerId) => {
        this._removeListener({
            channel: i.onTabButtonItemsAdded.channel,
            listenerId: listenerId,
        });
    };
    insertTabs = async (...args) => {
        return this._sendRequestPromise(i.insertTabs.channel, ...args);
    };
    onTabsInserted = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabsInserted.channel,
        });
    };
    unsetOnTabsInserted = async (listenerId) => {
        this._removeListener({
            channel: i.onTabsInserted.channel,
            listenerId: listenerId,
        });
    };
    insertTabSections = async (...args) => {
        return this._sendRequestPromise(i.insertTabSections.channel, ...args);
    };
    onTabSectionsInserted = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabSectionsInserted.channel,
        });
    };
    unsetOnTabSectionsInserted = async (listenerId) => {
        this._removeListener({
            channel: i.onTabSectionsInserted.channel,
            listenerId: listenerId,
        });
    };
    insertTabButtons = async (...args) => {
        return this._sendRequestPromise(i.insertTabButtons.channel, ...args);
    };
    onTabButtonsInserted = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabButtonsInserted.channel,
        });
    };
    unsetOnTabButtonsInserted = async (listenerId) => {
        this._removeListener({
            channel: i.onTabButtonsInserted.channel,
            listenerId: listenerId,
        });
    };
    insertTabButtonItems = async (...args) => {
        return this._sendRequestPromise(i.insertTabButtonItems.channel, ...args);
    };
    onTabButtonItemsInserted = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabButtonItemsInserted.channel,
        });
    };
    unsetOnTabButtonItemsInserted = async (listenerId) => {
        this._removeListener({
            channel: i.onTabButtonItemsInserted.channel,
            listenerId: listenerId,
        });
    };
    hasTab = async (...args) => {
        return this._sendRequestPromise(i.hasTab.channel, ...args);
    };
    hasTabSection = async (...args) => {
        return this._sendRequestPromise(i.hasTabSection.channel, ...args);
    };
    hasTabButton = async (...args) => {
        return this._sendRequestPromise(i.hasTabButton.channel, ...args);
    };
    hasTabButtonItem = async (...args) => {
        return this._sendRequestPromise(i.hasTabButtonItem.channel, ...args);
    };
    getTabTags = async (...args) => {
        return this._sendRequestPromise(i.getTabTags.channel, ...args);
    };
    getTabSectionTags = async (...args) => {
        return this._sendRequestPromise(i.getTabSectionTags.channel, ...args);
    };
    getTabButtonTags = async (...args) => {
        return this._sendRequestPromise(i.getTabButtonTags.channel, ...args);
    };
    getTabButtonItemTags = async (...args) => {
        return this._sendRequestPromise(i.getTabButtonItemTags.channel, ...args);
    };
    replaceTabs = async (...args) => {
        return this._sendRequestPromise(i.replaceTabs.channel, ...args);
    };
    onTabsReplaced = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabsReplaced.channel,
        });
    };
    unsetOnTabsReplaced = async (listenerId) => {
        this._removeListener({
            channel: i.onTabsReplaced.channel,
            listenerId: listenerId,
        });
    };
    replaceTabSections = async (...args) => {
        return this._sendRequestPromise(i.replaceTabSections.channel, ...args);
    };
    onTabSectionsReplaced = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabSectionsReplaced.channel,
        });
    };
    unsetOnTabSectionsReplaced = async (listenerId) => {
        this._removeListener({
            channel: i.onTabSectionsReplaced.channel,
            listenerId: listenerId,
        });
    };
    replaceTabButtons = async (...args) => {
        return this._sendRequestPromise(i.replaceTabButtons.channel, ...args);
    };
    onTabButtonsReplaced = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabButtonsReplaced.channel,
        });
    };
    unsetOnTabButtonsReplaced = async (listenerId) => {
        this._removeListener({
            channel: i.onTabButtonsReplaced.channel,
            listenerId: listenerId,
        });
    };
    replaceTabButtonItems = async (...args) => {
        return this._sendRequestPromise(i.replaceTabButtonItems.channel, ...args);
    };
    onTabButtonItemsReplaced = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabButtonItemsReplaced.channel,
        });
    };
    unsetOnTabButtonItemsReplaced = async (listenerId) => {
        this._removeListener({
            channel: i.onTabButtonItemsReplaced.channel,
            listenerId: listenerId,
        });
    };
    removeTabs = async (...args) => {
        return this._sendRequestPromise(i.removeTabs.channel, ...args);
    };
    onTabsRemoved = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabsRemoved.channel,
        });
    };
    unsetOnTabsRemoved = async (listenerId) => {
        this._removeListener({
            channel: i.onTabsRemoved.channel,
            listenerId: listenerId,
        });
    };
    removeTabSections = async (...args) => {
        return this._sendRequestPromise(i.removeTabSections.channel, ...args);
    };
    onTabSectionsRemoved = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabSectionsRemoved.channel,
        });
    };
    unsetOnTabSectionsRemoved = async (listenerId) => {
        this._removeListener({
            channel: i.onTabSectionsRemoved.channel,
            listenerId: listenerId,
        });
    };
    removeTabButtons = async (...args) => {
        return this._sendRequestPromise(i.removeTabButtons.channel, ...args);
    };
    onTabButtonsRemoved = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabButtonsRemoved.channel,
        });
    };
    unsetOnTabButtonsRemoved = async (listenerId) => {
        this._removeListener({
            channel: i.onTabButtonsRemoved.channel,
            listenerId: listenerId,
        });
    };
    removeTabButtonItems = async (...args) => {
        return this._sendRequestPromise(i.removeTabButtonItems.channel, ...args);
    };
    onTabButtonItemsRemoved = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabButtonItemsRemoved.channel,
        });
    };
    unsetOnTabButtonItemsRemoved = async (listenerId) => {
        this._removeListener({
            channel: i.onTabButtonItemsRemoved.channel,
            listenerId: listenerId,
        });
    };
    selectTab = async (...args) => {
        return this._sendRequestPromise(i.selectTab.channel, ...args);
    };
    selectTabSection = async (...args) => {
        return this._sendRequestPromise(i.selectTabSection.channel, ...args);
    };
    getSelectedTabTag = async (...args) => {
        return this._sendRequestPromise(i.getSelectedTabTag.channel, ...args);
    };
    getSelectedTabIndex = async (...args) => {
        return this._sendRequestPromise(i.getSelectedTabIndex.channel, ...args);
    };
    getSelectedTabSectionTag = async (...args) => {
        return this._sendRequestPromise(i.getSelectedTabSectionTag.channel, ...args);
    };
    getSelectedTabSectionIndex = async (...args) => {
        return this._sendRequestPromise(i.getSelectedTabSectionIndex.channel, ...args);
    };
    getTabIndex = async (...args) => {
        return this._sendRequestPromise(i.getTabIndex.channel, ...args);
    };
    getTabSectionIndex = async (...args) => {
        return this._sendRequestPromise(i.getTabSectionIndex.channel, ...args);
    };
    getTabButtonIndex = async (...args) => {
        return this._sendRequestPromise(i.getTabButtonIndex.channel, ...args);
    };
    getTabButtonItemIndex = async (...args) => {
        return this._sendRequestPromise(i.getTabButtonItemIndex.channel, ...args);
    };
}
