import { ApiRequestListener, ApiListenerId } from '../interfaces/i_api_listener';
export declare abstract class FrontApiBase {
    private _listenersController;
    protected _addAndGetListenerId(listener: ApiRequestListener, args: {
        channel: string;
        isOnce?: boolean;
    }): ApiListenerId | undefined;
    protected _addListener<ListenerType extends ApiRequestListener, OnFunctionType extends (listener: ListenerType, extraArgs: {
        listenerId?: ApiListenerId;
    }) => Promise<void>>(listener: ListenerType, args: {
        onFunction: OnFunctionType;
        channel: string;
        extra?: {
            isOnce?: boolean;
        };
    }): Promise<void>;
    protected _removeListener<ListenerType extends ApiRequestListener, UnsetFunctionType extends (listenerId?: ApiListenerId) => Promise<void>>(listener: ListenerType | undefined, args: {
        unsetFunction: UnsetFunctionType;
        channel: string;
    }): Promise<void>;
}
