import { ApiListenersController } from '../classes/api_listeners_controller';
export class FrontApiBase {
    _listenersController = new ApiListenersController();
    _addAndGetListenerId(listener, args) {
        if (args.isOnce) {
            return undefined;
        }
        return this._listenersController.addListener(listener, {
            channel: args.channel,
        });
    }
    _addListener(listener, args) {
        const listenerId = this._addAndGetListenerId(listener, {
            channel: args.channel,
            isOnce: args.extra?.isOnce,
        });
        return args.onFunction(listener, { ...args.extra, listenerId: listenerId });
    }
    _removeListener(listener, args) {
        if (listener === undefined) {
            this._listenersController.removeAllListeners({
                channel: args.channel,
            });
            return args.unsetFunction();
        }
        else {
            const listenerId = this._listenersController.getListenerId(listener, {
                channel: args.channel,
            });
            this._listenersController.removeListener(listener, {
                channel: args.channel,
            });
            return args.unsetFunction(listenerId);
        }
    }
}
