import { lifecycleApiInfoPreload as i } from '../interfaces/i_lifecycle_api_info_preload';
import { PreloadApiBase } from '../classes/preload_api_base';
export class LifecyclePreloadApi extends PreloadApiBase {
    constructor(ipcRenderer) {
        super(ipcRenderer);
    }
    onReady = async (listener) => {
        this._addListener(listener, { channel: i.onReady.channel });
    };
    onDestroy = async (listener) => {
        this._addListener(listener, { channel: i.onDestroy.channel });
    };
    onDidGoBackground = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onDidGoBackground.channel,
        });
    };
    unsetOnDidGoBackground = async (listenerId) => {
        this._removeListener({
            channel: i.onDidGoBackground.channel,
            listenerId: listenerId,
        });
    };
    onDidGoForeground = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onDidGoForeground.channel,
        });
    };
    unsetOnDidGoForeground = async (listenerId) => {
        this._removeListener({
            channel: i.onDidGoForeground.channel,
            listenerId: listenerId,
        });
    };
}
