import { PreloadApiBase } from '../classes/preload_api_base';
import { mainPanelApiInfoPreload as i } from '../interfaces/i_main_panel_api_info_preload';
export class MainPanelPreloadApi extends PreloadApiBase {
    constructor(ipcRenderer) {
        super(ipcRenderer);
    }
    setTabs = async (...args) => {
        return this._sendRequestPromise(i.setTabs.channel, ...args);
    };
    onTabsSet = async (listener, extraArgs) => {
        this._addListener(listener, { ...extraArgs, channel: i.onTabsSet.channel });
    };
    unsetOnTabsSet = async (listenerId) => {
        this._removeListener({
            channel: i.onTabsSet.channel,
            listenerId: listenerId,
        });
    };
    addTabs = async (...args) => {
        return this._sendRequestPromise(i.addTabs.channel, ...args);
    };
    onTabsAdded = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabsAdded.channel,
        });
    };
    unsetOnTabsAdded = async (listenerId) => {
        this._removeListener({
            channel: i.onTabsAdded.channel,
            listenerId: listenerId,
        });
    };
    insertTabs = async (...args) => {
        return this._sendRequestPromise(i.insertTabs.channel, ...args);
    };
    onTabsInserted = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabsInserted.channel,
        });
    };
    unsetOnTabsInserted = async (listenerId) => {
        this._removeListener({
            channel: i.onTabsInserted.channel,
            listenerId: listenerId,
        });
    };
    hasTab = async (...args) => {
        return this._sendRequestPromise(i.hasTab.channel, ...args);
    };
    getTabTags = async (...args) => {
        return this._sendRequestPromise(i.getTabTags.channel, ...args);
    };
    replaceTabs = async (...args) => {
        return this._sendRequestPromise(i.replaceTabs.channel, ...args);
    };
    onTabsReplaced = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabsReplaced.channel,
        });
    };
    unsetOnTabsReplaced = async (listenerId) => {
        this._removeListener({
            channel: i.onTabsReplaced.channel,
            listenerId: listenerId,
        });
    };
    removeTabs = async (...args) => {
        return this._sendRequestPromise(i.removeTabs.channel, ...args);
    };
    onTabsRemoved = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onTabsRemoved.channel,
        });
    };
    unsetOnTabsRemoved = async (listenerId) => {
        this._removeListener({
            channel: i.onTabsRemoved.channel,
            listenerId: listenerId,
        });
    };
    selectTab = async (...args) => {
        return this._sendRequestPromise(i.selectTab.channel, ...args);
    };
    getSelectedTabTag = async (...args) => {
        return this._sendRequestPromise(i.getSelectedTabTag.channel, ...args);
    };
    getSelectedTabIndex = async (...args) => {
        return this._sendRequestPromise(i.getSelectedTabIndex.channel, ...args);
    };
    getTabIndex = async (...args) => {
        return this._sendRequestPromise(i.getTabIndex.channel, ...args);
    };
}
