import { nodeApiInfoPreload as i } from '../interfaces/i_node_api_info_preload';
import { PreloadApiBase } from '../classes/preload_api_base';
export class NodePreloadApi extends PreloadApiBase {
    constructor(ipcRenderer) {
        super(ipcRenderer);
    }
    sendData = async (...args) => {
        return this._sendRequestPromise(i.sendData.channel, ...args);
    };
    onDataReceived = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onDataReceived.channel,
        });
    };
    unsetOnDataReceived = async (listenerId) => {
        this._removeListener({
            channel: i.onDataReceived.channel,
            listenerId: listenerId,
        });
    };
    sendEvent = async (...args) => {
        return this._sendRequestPromise(i.sendEvent.channel, ...args);
    };
    onEventReceived = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onEventReceived.channel,
        });
    };
    unsetOnEventReceived = async (listenerId) => {
        this._removeListener({
            channel: i.onEventReceived.channel,
            listenerId: listenerId,
        });
    };
}
