import { pingPongApiInfoPreload as i } from '../interfaces/i_ping_pong_api_info_preload';
import { PreloadApiBase } from '../classes/preload_api_base';
export class PingPongPreloadApi extends PreloadApiBase {
    constructor(ipcRenderer) {
        super(ipcRenderer);
    }
    ping = async (...args) => {
        return this._sendRequestPromise(i.ping.channel, ...args);
    };
    onPing = async (listener, extraArgs) => {
        this._addListener(listener, { ...extraArgs, channel: i.onPing.channel });
    };
    unsetOnPing = async (listenerId) => {
        this._removeListener({ channel: i.onPing.channel, listenerId: listenerId });
    };
    pong = async (...args) => {
        return this._sendRequestPromise(i.pong.channel, ...args);
    };
    onPong = async (listener, extraArgs) => {
        this._addListener(listener, { ...extraArgs, channel: i.onPong.channel });
    };
    unsetOnPong = async (listenerId) => {
        this._removeListener({ channel: i.onPong.channel, listenerId: listenerId });
    };
}
