import { IpcRenderer } from '../classes/electron';
import { ApiRequestListener, ApiListenerId } from '../interfaces/i_api_listener';
import { ApiRequestChannel } from '../interfaces/i_api_request';
export declare abstract class PreloadApiBase {
    private _ipcRenderer;
    private _preloadListenersController;
    constructor(ipcRenderer: IpcRenderer);
    protected _sendRequestPromise<ResultType>(channel: ApiRequestChannel, ...payload: any): Promise<ResultType>;
    protected _addListener<ListenerType extends ApiRequestListener>(listener: ListenerType, args: {
        channel: string;
        listenerId?: ApiListenerId;
    }): void;
    protected _removeListener(args: {
        channel: ApiRequestChannel;
        listenerId?: ApiListenerId;
    }): void;
}
