import { PreloadApiBase } from '../classes/preload_api_base';
import { storageApiInfoPreload as i } from '../interfaces/i_storage_api_info_preload';
export class StoragePreloadApi extends PreloadApiBase {
    constructor(ipcRenderer) {
        super(ipcRenderer);
    }
    has = async (...args) => {
        return this._sendRequestPromise(i.has.channel, ...args);
    };
    get = async (...args) => {
        return this._sendRequestPromise(i.get.channel, ...args);
    };
    set = async (...args) => {
        return this._sendRequestPromise(i.set.channel, ...args);
    };
    onSet = async (listener, extraArgs) => {
        this._addListener(listener, { ...extraArgs, channel: i.onSet.channel });
    };
    unsetOnSet = async (listenerId) => {
        this._removeListener({ channel: i.onSet.channel, listenerId: listenerId });
    };
    delete = async (...args) => {
        return this._sendRequestPromise(i.delete_.channel, ...args);
    };
    onDeleted = async (listener, extraArgs) => {
        this._addListener(listener, { ...extraArgs, channel: i.onDeleted.channel });
    };
    unsetOnDelete = async (listenerId) => {
        this._removeListener({
            channel: i.onDeleted.channel,
            listenerId: listenerId,
        });
    };
    getAll = async (...args) => {
        return this._sendRequestPromise(i.getAll.channel, ...args);
    };
    clear = async (...args) => {
        return this._sendRequestPromise(i.clear.channel, ...args);
    };
    onCleared = async (listener, extraArgs) => {
        this._addListener(listener, { ...extraArgs, channel: i.onCleared.channel });
    };
    unsetOnClear = async (listenerId) => {
        this._removeListener({
            channel: i.onCleared.channel,
            listenerId: listenerId,
        });
    };
    onChangeed = async (listener, extraArgs) => {
        this._addListener(listener, {
            ...extraArgs,
            channel: i.onChangeed.channel,
        });
    };
    unsetOnChange = async (listenerId) => {
        this._removeListener({
            channel: i.onChangeed.channel,
            listenerId: listenerId,
        });
    };
}
