import { controlPanelApiInfo as i } from '../interfaces/i_control_panel_api_info';
import { FrontApiBase } from '../classes/front_api_base';
const preloadApi = window
    .__controlPanelPreloadApi__;
export class ControlPanelFrontApi extends FrontApiBase {
    onGetInitialTabs = async (listener) => {
        this._addListener(listener, {
            onFunction: preloadApi.onGetInitialTabs,
            channel: i.onGetInitialTabs.channel,
        });
    };
    setTabs = async (...args) => {
        return preloadApi.setTabs(...args);
    };
    onTabsSet = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabsSet,
            channel: i.onTabsSet.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabsSet = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabsSet,
            channel: i.onTabsSet.channel,
        });
    };
    setTabSections = async (...args) => {
        return preloadApi.setTabSections(...args);
    };
    onTabSectionsSet = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabSectionsSet,
            channel: i.onTabSectionsSet.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabSectionsSet = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabSectionsSet,
            channel: i.onTabSectionsSet.channel,
        });
    };
    setTabButtons = async (...args) => {
        return preloadApi.setTabButtons(...args);
    };
    onTabButtonsSet = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabButtonsSet,
            channel: i.onTabButtonsSet.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabButtonsSet = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabButtonsSet,
            channel: i.onTabButtonsSet.channel,
        });
    };
    setTabButtonItems = async (...args) => {
        return preloadApi.setTabButtonItems(...args);
    };
    onTabButtonItemsSet = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabButtonItemsSet,
            channel: i.onTabButtonItemsSet.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabButtonItemsSet = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabButtonItemsSet,
            channel: i.onTabButtonItemsSet.channel,
        });
    };
    addTabs = async (...args) => {
        return preloadApi.addTabs(...args);
    };
    onTabsAdded = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabsAdded,
            channel: i.onTabsAdded.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabsAdded = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabsAdded,
            channel: i.onTabsAdded.channel,
        });
    };
    addTabSections = async (...args) => {
        return preloadApi.addTabSections(...args);
    };
    onTabSectionsAdded = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabSectionsAdded,
            channel: i.onTabSectionsAdded.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabSectionsAdded = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabSectionsAdded,
            channel: i.onTabSectionsAdded.channel,
        });
    };
    addTabButtons = async (...args) => {
        return preloadApi.addTabButtons(...args);
    };
    onTabButtonsAdded = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabButtonsAdded,
            channel: i.onTabButtonsAdded.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabButtonsAdded = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabButtonsAdded,
            channel: i.onTabButtonsAdded.channel,
        });
    };
    addTabButtonItems = async (...args) => {
        return preloadApi.addTabButtonItems(...args);
    };
    onTabButtonItemsAdded = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabButtonItemsAdded,
            channel: i.onTabButtonItemsAdded.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabButtonItemsAdded = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabButtonItemsAdded,
            channel: i.onTabButtonItemsAdded.channel,
        });
    };
    insertTabs = async (...args) => {
        return preloadApi.insertTabs(...args);
    };
    onTabsInserted = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabsInserted,
            channel: i.onTabsInserted.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabsInserted = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabsInserted,
            channel: i.onTabsInserted.channel,
        });
    };
    insertTabSections = async (...args) => {
        return preloadApi.insertTabSections(...args);
    };
    onTabSectionsInserted = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabSectionsInserted,
            channel: i.onTabSectionsInserted.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabSectionsInserted = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabSectionsInserted,
            channel: i.onTabSectionsInserted.channel,
        });
    };
    insertTabButtons = async (...args) => {
        return preloadApi.insertTabButtons(...args);
    };
    onTabButtonsInserted = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabButtonsInserted,
            channel: i.onTabButtonsInserted.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabButtonsInserted = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabButtonsInserted,
            channel: i.onTabButtonsInserted.channel,
        });
    };
    insertTabButtonItems = async (...args) => {
        return preloadApi.insertTabButtonItems(...args);
    };
    onTabButtonItemsInserted = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabButtonItemsInserted,
            channel: i.onTabButtonItemsInserted.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabButtonItemsInserted = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabButtonItemsInserted,
            channel: i.onTabButtonItemsInserted.channel,
        });
    };
    hasTab = async (...args) => {
        return preloadApi.hasTab(...args);
    };
    hasTabSection = async (...args) => {
        return preloadApi.hasTabSection(...args);
    };
    hasTabButton = async (...args) => {
        return preloadApi.hasTabButton(...args);
    };
    hasTabButtonItem = async (...args) => {
        return preloadApi.hasTabButtonItem(...args);
    };
    getTabTags = async (...args) => {
        return preloadApi.getTabTags(...args);
    };
    getTabSectionTags = async (...args) => {
        return preloadApi.getTabSectionTags(...args);
    };
    getTabButtonTags = async (...args) => {
        return preloadApi.getTabButtonTags(...args);
    };
    getTabButtonItemTags = async (...args) => {
        return preloadApi.getTabButtonItemTags(...args);
    };
    replaceTabs = async (...args) => {
        return preloadApi.replaceTabs(...args);
    };
    onTabsReplaced = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabsReplaced,
            channel: i.onTabsReplaced.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabsReplaced = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabsReplaced,
            channel: i.onTabsReplaced.channel,
        });
    };
    replaceTabSections = async (...args) => {
        return preloadApi.replaceTabSections(...args);
    };
    onTabSectionsReplaced = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabSectionsReplaced,
            channel: i.onTabSectionsReplaced.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabSectionsReplaced = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabSectionsReplaced,
            channel: i.onTabSectionsReplaced.channel,
        });
    };
    replaceTabButtons = async (...args) => {
        return preloadApi.replaceTabButtons(...args);
    };
    onTabButtonsReplaced = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabButtonsReplaced,
            channel: i.onTabButtonsReplaced.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabButtonsReplaced = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabButtonsReplaced,
            channel: i.onTabButtonsReplaced.channel,
        });
    };
    replaceTabButtonItems = async (...args) => {
        return preloadApi.replaceTabButtonItems(...args);
    };
    onTabButtonItemsReplaced = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabButtonItemsReplaced,
            channel: i.onTabButtonItemsReplaced.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabButtonItemsReplaced = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabButtonItemsReplaced,
            channel: i.onTabButtonItemsReplaced.channel,
        });
    };
    removeTabs = async (...args) => {
        return preloadApi.removeTabs(...args);
    };
    onTabsRemoved = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabsRemoved,
            channel: i.onTabsRemoved.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabsRemoved = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabsRemoved,
            channel: i.onTabsRemoved.channel,
        });
    };
    removeTabSections = async (...args) => {
        return preloadApi.removeTabSections(...args);
    };
    onTabSectionsRemoved = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabSectionsRemoved,
            channel: i.onTabSectionsRemoved.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabSectionsRemoved = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabSectionsRemoved,
            channel: i.onTabSectionsRemoved.channel,
        });
    };
    removeTabButtons = async (...args) => {
        return preloadApi.removeTabButtons(...args);
    };
    onTabButtonsRemoved = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabButtonsRemoved,
            channel: i.onTabButtonsRemoved.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabButtonsRemoved = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabButtonsRemoved,
            channel: i.onTabButtonsRemoved.channel,
        });
    };
    removeTabButtonItems = async (...args) => {
        return preloadApi.removeTabButtonItems(...args);
    };
    onTabButtonItemsRemoved = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabButtonItemsRemoved,
            channel: i.onTabButtonItemsRemoved.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabButtonItemsRemoved = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabButtonItemsRemoved,
            channel: i.onTabButtonItemsRemoved.channel,
        });
    };
    selectTab = async (...args) => {
        return preloadApi.selectTab(...args);
    };
    selectTabSection = async (...args) => {
        return preloadApi.selectTabSection(...args);
    };
    getSelectedTabTag = async (...args) => {
        return preloadApi.getSelectedTabTag(...args);
    };
    getSelectedTabIndex = async (...args) => {
        return preloadApi.getSelectedTabIndex(...args);
    };
    getSelectedTabSectionTag = async (...args) => {
        return preloadApi.getSelectedTabSectionTag(...args);
    };
    getSelectedTabSectionIndex = async (...args) => {
        return preloadApi.getSelectedTabSectionIndex(...args);
    };
    getTabIndex = async (...args) => {
        return preloadApi.getTabIndex(...args);
    };
    getTabSectionIndex = async (...args) => {
        return preloadApi.getTabSectionIndex(...args);
    };
    getTabButtonIndex = async (...args) => {
        return preloadApi.getTabButtonIndex(...args);
    };
    getTabButtonItemIndex = async (...args) => {
        return preloadApi.getTabButtonItemIndex(...args);
    };
}
