import { lifecycleApiInfo as i } from '../interfaces/i_lifecycle_api_info';
import { FrontApiBase } from '../classes/front_api_base';
const preloadApi = window.__lifecyclePreloadApi__;
export class LifecycleFrontApi extends FrontApiBase {
    onReady = async (listener) => {
        this._addListener(listener, {
            onFunction: preloadApi.onReady,
            channel: i.onReady.channel,
            extra: { isOnce: true },
        });
    };
    onDestroy = async (listener) => {
        this._addListener(listener, {
            onFunction: preloadApi.onDestroy,
            channel: i.onDestroy.channel,
            extra: { isOnce: true },
        });
    };
    onDidGoBackground = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onDidGoBackground,
            channel: i.onDidGoBackground.channel,
            extra: extraArgs,
        });
    };
    unsetOnDidGoBackground = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnDidGoBackground,
            channel: i.onDidGoBackground.channel,
        });
    };
    onDidGoForeground = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onDidGoForeground,
            channel: i.onDidGoForeground.channel,
            extra: extraArgs,
        });
    };
    unsetOnDidGoForeground = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnDidGoForeground,
            channel: i.onDidGoForeground.channel,
        });
    };
}
