import { mainPanelApiInfo as i } from '../interfaces/i_main_panel_api_info';
import { FrontApiBase } from '../classes/front_api_base';
const preloadApi = window.__mainPanelPreloadApi__;
export class MainPanelFrontApi extends FrontApiBase {
    setTabs = async (...args) => {
        return preloadApi.setTabs(...args);
    };
    onTabsSet = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabsSet,
            channel: i.onTabsSet.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabsSet = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabsSet,
            channel: i.onTabsSet.channel,
        });
    };
    addTabs = async (...args) => {
        return preloadApi.addTabs(...args);
    };
    onTabsAdded = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabsAdded,
            channel: i.onTabsAdded.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabsAdded = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabsAdded,
            channel: i.onTabsAdded.channel,
        });
    };
    insertTabs = async (...args) => {
        return preloadApi.insertTabs(...args);
    };
    onTabsInserted = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabsInserted,
            channel: i.onTabsInserted.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabsInserted = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabsInserted,
            channel: i.onTabsInserted.channel,
        });
    };
    hasTab = async (...args) => {
        return preloadApi.hasTab(...args);
    };
    getTabTags = async (...args) => {
        return preloadApi.getTabTags(...args);
    };
    replaceTabs = async (...args) => {
        return preloadApi.replaceTabs(...args);
    };
    onTabsReplaced = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabsReplaced,
            channel: i.onTabsReplaced.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabsReplaced = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabsReplaced,
            channel: i.onTabsReplaced.channel,
        });
    };
    removeTabs = async (...args) => {
        return preloadApi.removeTabs(...args);
    };
    onTabsRemoved = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onTabsRemoved,
            channel: i.onTabsRemoved.channel,
            extra: extraArgs,
        });
    };
    unsetOnTabsRemoved = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnTabsRemoved,
            channel: i.onTabsRemoved.channel,
        });
    };
    selectTab = async (...args) => {
        return preloadApi.selectTab(...args);
    };
    getSelectedTabTag = async (...args) => {
        return preloadApi.getSelectedTabTag(...args);
    };
    getSelectedTabIndex = async (...args) => {
        return preloadApi.getSelectedTabIndex(...args);
    };
    getTabIndex = async (...args) => {
        return preloadApi.getTabIndex(...args);
    };
}
