import { nodeApiInfo as i } from '../interfaces/i_node_api_info';
import { gRootTrackingTag } from '../interfaces/i_tracking_tag';
import { FrontApiBase } from '../classes/front_api_base';
const preloadApi = window.__nodePreloadApi__;
export class NodeFrontApi extends FrontApiBase {
    rootTag = gRootTrackingTag;
    sendData = async (...args) => {
        return preloadApi.sendData(...args);
    };
    onDataReceived = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onDataReceived,
            channel: i.onDataReceived.channel,
            extra: extraArgs,
        });
    };
    unsetOnDataReceived = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnDataReceived,
            channel: i.onDataReceived.channel,
        });
    };
    sendEvent = async (...args) => {
        return preloadApi.sendEvent(...args);
    };
    onEventReceived = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onEventReceived,
            channel: i.onEventReceived.channel,
            extra: extraArgs,
        });
    };
    unsetOnEventReceived = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnEventReceived,
            channel: i.onEventReceived.channel,
        });
    };
}
