import { pingPongApiInfo as i } from '../interfaces/i_ping_pong_api_info';
import { FrontApiBase } from '../classes/front_api_base';
const preloadApi = window.__pingPongPreloadApi__;
export class PingPongFrontApi extends FrontApiBase {
    ping = async (...args) => {
        return preloadApi.ping(...args);
    };
    onPing = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onPing,
            channel: i.onPing.channel,
            extra: extraArgs,
        });
    };
    unsetOnPing = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnPing,
            channel: i.onPing.channel,
        });
    };
    pong = async (...args) => {
        return preloadApi.pong(...args);
    };
    onPong = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onPong,
            channel: i.onPong.channel,
            extra: extraArgs,
        });
    };
    unsetOnPong = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnPong,
            channel: i.onPong.channel,
        });
    };
}
