import { FrontApiBase } from '../classes/front_api_base';
import { storageApiInfo as i } from '../interfaces/i_storage_api_info';
const preloadApi = window.__storagePreloadApi__;
export class StorageFrontApi extends FrontApiBase {
    has = async (...args) => {
        return preloadApi.has(...args);
    };
    get = async (...args) => {
        return preloadApi.get(...args);
    };
    set = async (...args) => {
        return preloadApi.set(...args);
    };
    onSet = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onSet,
            channel: i.onSet.channel,
            extra: extraArgs,
        });
    };
    unsetOnSet = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnSet,
            channel: i.onSet.channel,
        });
    };
    delete = async (...args) => {
        return preloadApi.delete(...args);
    };
    onDeleted = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onDeleted,
            channel: i.onDeleted.channel,
            extra: extraArgs,
        });
    };
    unsetOnDelete = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnDelete,
            channel: i.onDeleted.channel,
        });
    };
    getAll = async (...args) => {
        return preloadApi.getAll(...args);
    };
    clear = async (...args) => {
        return preloadApi.clear(...args);
    };
    onCleared = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onCleared,
            channel: i.onCleared.channel,
            extra: extraArgs,
        });
    };
    unsetOnClear = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnClear,
            channel: i.onCleared.channel,
        });
    };
    onChangeed = async (listener, extraArgs) => {
        this._addListener(listener, {
            onFunction: preloadApi.onChangeed,
            channel: i.onChangeed.channel,
            extra: extraArgs,
        });
    };
    unsetOnChange = async (listener) => {
        this._removeListener(listener, {
            unsetFunction: preloadApi.unsetOnSet,
            channel: i.onChangeed.channel,
        });
    };
}
