import { ISemver } from '../interfaces/i_semver';
export declare enum Api {
    AppInfo = "appInfo",
    AppMenu = "appMenuApi",
    Cache = "cacheApi",
    CodeEditor = "codeEditorApi",
    Commands = "commandsApi",
    Communication = "communicationApi",
    ContextMenu = "contextMenuApi",
    ControlPanel = "controlPanelApi",
    Database = "databaseApi",
    ExtensionInfo = "extensionInfoApi",
    FileExplorer = "fileExplorerApi",
    FileSystem = "fileSystemApi",
    Hotkeys = "hotkeysApi",
    Lifecycle = "lifecycleApi",
    MainPanel = "mainPanelApi",
    Node = "nodeApi",
    Notifications = "notificationsApi",
    Path = "pathApi",
    PingPong = "pingPongApi",
    Processes = "processesApi",
    Settings = "settingsApi",
    StatusBar = "statusBarApi",
    Storage = "storageApi",
    Tags = "tagsApi",
    Web = "webApi"
}
export type DefaultRequiredApi = Api.Lifecycle;
export declare const defaultRequiredApis: Set<Api>;
export type RequirableApi = Api;
export declare const requirableApis: Set<Api>;
export type ImplementableApi = Api.CodeEditor | Api.Database | Api.FileExplorer;
export declare const implementableApis: Set<ImplementableApi>;
export declare enum ApiVersionState {
    Green = "green",
    Yellow = "yellow",
    Red = "red"
}
export interface IApiVersionInfo {
    readonly version: ISemver;
    readonly versionState: ApiVersionState;
}
