import { Api } from '../interfaces/i_api';
import { TrackingTag } from '../interfaces/i_tracking_tag';
import { ApiInfoType } from '../interfaces/i_api_info';
import { ICPTabInfo } from '../interfaces/i_cp_tab_info';
import { ICPTabSectionInfo } from '../interfaces/i_cp_tab_section_info';
import { ICPTabButtonInfo } from '../interfaces/i_cp_tab_button_info';
import { ICPTabButtonItemInfo } from '../interfaces/i_cp_tab_button_item_info';
export declare namespace controlPanelApiInfo {
    const api = Api.ControlPanel;
    const apiInfoType = ApiInfoType.Main;
    enum Channel {
        OnGetInitialTabs = "controlPanelApi.onGetInitialTabs",
        SetTabs = "controlPanelApi.setTabs",
        OnTabsSet = "controlPanelApi.onTabsSet",
        SetTabSections = "controlPanelApi.setTabSections",
        OnTabSectionsSet = "controlPanelApi.onTabSectionsSet",
        SetTabButtons = "controlPanelApi.setTabButtons",
        OnTabButtonsSet = "controlPanelApi.onTabButtonsSet",
        SetTabButtonItems = "controlPanelApi.setTabButtonItems",
        OnTabButtonItemsSet = "controlPanelApi.onTabButtonItemsSet",
        AddTabs = "controlPanelApi.addTabs",
        OnTabsAdded = "controlPanelApi.onTabsAdded",
        AddTabSections = "controlPanelApi.addTabSections",
        OnTabSectionsAdded = "controlPanelApi.onTabSectionsAdded",
        AddTabButtons = "controlPanelApi.addTabButtons",
        OnTabButtonsAdded = "controlPanelApi.onTabButtonsAdded",
        AddTabButtonItems = "controlPanelApi.addTabButtonItems",
        OnTabButtonItemsAdded = "controlPanelApi.onTabButtonItemsAdded",
        InsertTabs = "controlPanelApi.insertTabs",
        OnTabsInserted = "controlPanelApi.onTabsInserted",
        InsertTabSections = "controlPanelApi.insertTabSections",
        OnTabSectionsInserted = "controlPanelApi.onTabSectionsInserted",
        InsertTabButtons = "controlPanelApi.insertTabButtons",
        OnTabButtonsInserted = "controlPanelApi.onTabButtonsInserted",
        InsertTabButtonItems = "controlPanelApi.insertTabButtonItems",
        OnTabButtonItemsInserted = "controlPanelApi.onTabButtonItemsInserted",
        HasTab = "controlPanelApi.hasTab",
        HasTabSection = "controlPanelApi.hasTabSection",
        HasTabButton = "controlPanelApi.hasTabButton",
        HasTabButtonItem = "controlPanelApi.hasTabButtonItem",
        GetTabTags = "controlPanelApi.getTabTags",
        GetTabSectionTags = "controlPanelApi.getTabSectionTags",
        GetTabButtonTags = "controlPanelApi.getTabButtonTags",
        GetTabButtonItemTags = "controlPanelApi.getTabButtonItemTags",
        ReplaceTabs = "controlPanelApi.replaceTabs",
        OnTabsReplaced = "controlPanelApi.onTabsReplaced",
        ReplaceTabSections = "controlPanelApi.replaceTabSections",
        OnTabSectionsReplaced = "controlPanelApi.onTabSectionsReplaced",
        ReplaceTabButtons = "controlPanelApi.replaceTabButtons",
        OnTabButtonsReplaced = "controlPanelApi.onTabButtonsReplaced",
        ReplaceTabButtonItems = "controlPanelApi.replaceTabButtonItems",
        OnTabButtonItemsReplaced = "controlPanelApi.onTabButtonItemsReplaced",
        RemoveTabs = "controlPanelApi.removeTabs",
        OnTabsRemoved = "controlPanelApi.onTabsRemoved",
        RemoveTabSections = "controlPanelApi.removeTabSections",
        OnTabSectionsRemoved = "controlPanelApi.onTabSectionsRemoved",
        RemoveTabButtons = "controlPanelApi.removeTabButtons",
        OnTabButtonsRemoved = "controlPanelApi.onTabButtonsRemoved",
        RemoveTabButtonItems = "controlPanelApi.removeTabButtonItems",
        OnTabButtonItemsRemoved = "controlPanelApi.onTabButtonItemsRemoved",
        SelectTab = "controlPanelApi.selectTab",
        SelectTabSection = "controlPanelApi.selectTabSection",
        GetSelectedTabTag = "controlPanelApi.getSelectedTabTag",
        GetSelectedTabIndex = "controlPanelApi.getSelectedTabIndex",
        GetSelectedTabSectionTag = "controlPanelApi.getSelectedTabSectionTag",
        GetSelectedTabSectionIndex = "controlPanelApi.getSelectedTabSectionIndex",
        GetTabIndex = "controlPanelApi.getTabIndex",
        GetTabSectionIndex = "controlPanelApi.getTabSectionIndex",
        GetTabButtonIndex = "controlPanelApi.getTabButtonIndex",
        GetTabButtonItemIndex = "controlPanelApi.getTabButtonItemIndex"
    }
    namespace onGetInitialTabs {
        const channel = Channel.OnGetInitialTabs;
        namespace listener {
            type ArgsType = [];
            type ResultType = ICPTabInfo[];
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type ArgsType = [listener: ListenerType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace setTabs {
        const channel = Channel.SetTabs;
        type ArgsType = [...tabsInfo: ICPTabInfo[]];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabsSet {
        const channel = Channel.OnTabsSet;
        namespace listener {
            type ArgsType = [...tabTags: TrackingTag[]];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace setTabSections {
        const channel = Channel.SetTabSections;
        type InnerArgsType = {
            tabTag: TrackingTag;
        };
        type ArgsType = [
            sectionsInfo: ICPTabSectionInfo[],
            args: InnerArgsType
        ];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabSectionsSet {
        const channel = Channel.OnTabSectionsSet;
        namespace listener {
            type ArgsType = [
                sectionTags: TrackingTag[],
                args: setTabSections.InnerArgsType
            ];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace setTabButtons {
        const channel = Channel.SetTabButtons;
        type InnerArgsType = {
            tabOrSectionTag: TrackingTag;
        };
        type ArgsType = [
            buttonsInfo: ICPTabButtonInfo[],
            args: InnerArgsType
        ];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabButtonsSet {
        const channel = Channel.OnTabButtonsSet;
        namespace listener {
            type ArgsType = [
                buttonTags: TrackingTag[],
                args: setTabButtons.InnerArgsType
            ];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace setTabButtonItems {
        const channel = Channel.SetTabButtonItems;
        type InnerArgsType = {
            buttonOrItemTag: TrackingTag;
        };
        type ArgsType = [
            itemsInfo: ICPTabButtonItemInfo[],
            args: InnerArgsType
        ];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabButtonItemsSet {
        const channel = Channel.OnTabButtonItemsSet;
        namespace listener {
            type ArgsType = [
                itemTags: TrackingTag[],
                args: setTabButtonItems.InnerArgsType
            ];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace addTabs {
        const channel = Channel.AddTabs;
        type ArgsType = [...tabsInfo: ICPTabInfo[]];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabsAdded {
        const channel = Channel.OnTabsAdded;
        namespace listener {
            type ArgsType = [...tabTags: TrackingTag[]];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace addTabSections {
        const channel = Channel.AddTabSections;
        type InnerArgsType = {
            tabTag: TrackingTag;
        };
        type ArgsType = [
            sectionsInfo: ICPTabSectionInfo[],
            args: InnerArgsType
        ];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabSectionsAdded {
        const channel = Channel.OnTabSectionsAdded;
        namespace listener {
            type ArgsType = [
                sectionTags: TrackingTag[],
                args: addTabSections.InnerArgsType
            ];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace addTabButtons {
        const channel = Channel.AddTabButtons;
        type InnerArgsType = {
            tabOrSectionTag: TrackingTag;
        };
        type ArgsType = [
            buttonsInfo: ICPTabButtonInfo[],
            args: InnerArgsType
        ];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabButtonsAdded {
        const channel = Channel.OnTabButtonsAdded;
        namespace listener {
            type ArgsType = [
                buttonTags: TrackingTag[],
                args: addTabButtons.InnerArgsType
            ];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace addTabButtonItems {
        const channel = Channel.AddTabButtonItems;
        type InnerArgsType = {
            buttonOrItemTag: TrackingTag;
        };
        type ArgsType = [
            itemsInfo: ICPTabButtonItemInfo[],
            args: InnerArgsType
        ];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabButtonItemsAdded {
        const channel = Channel.OnTabButtonItemsAdded;
        namespace listener {
            type ArgsType = [
                itemTags: TrackingTag[],
                args: addTabButtonItems.InnerArgsType
            ];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace insertTabs {
        const channel = Channel.InsertTabs;
        type InnerArgsType = {
            atIndex: number;
        };
        type ArgsType = [tabsInfo: ICPTabInfo[], args: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabsInserted {
        const channel = Channel.OnTabsInserted;
        namespace listener {
            type ArgsType = [
                tabTags: TrackingTag[],
                args: insertTabs.InnerArgsType
            ];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace insertTabSections {
        const channel = Channel.InsertTabSections;
        type InnerArgsType = {
            tabTag: TrackingTag;
            atIndex: number;
        };
        type ArgsType = [
            sectionsInfo: ICPTabSectionInfo[],
            args: InnerArgsType
        ];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabSectionsInserted {
        const channel = Channel.OnTabSectionsInserted;
        namespace listener {
            type ArgsType = [
                sectionTags: TrackingTag[],
                args: insertTabSections.InnerArgsType
            ];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace insertTabButtons {
        const channel = Channel.InsertTabButtons;
        type InnerArgsType = {
            tabOrSectionTag: TrackingTag;
            atIndex: number;
        };
        type ArgsType = [
            buttonsInfo: ICPTabButtonInfo[],
            args: InnerArgsType
        ];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabButtonsInserted {
        const channel = Channel.OnTabButtonsInserted;
        namespace listener {
            type ArgsType = [
                buttonTags: TrackingTag[],
                args: insertTabButtons.InnerArgsType
            ];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace insertTabButtonItems {
        const channel = Channel.InsertTabButtonItems;
        type InnerArgsType = {
            buttonOrItemTag: TrackingTag;
            atIndex: number;
        };
        type ArgsType = [
            itemsInfo: ICPTabButtonItemInfo[],
            args: InnerArgsType
        ];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabButtonItemsInserted {
        const channel = Channel.OnTabButtonItemsInserted;
        namespace listener {
            type ArgsType = [
                itemTags: TrackingTag[],
                args: insertTabButtonItems.InnerArgsType
            ];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace hasTab {
        const channel = Channel.HasTab;
        type ArgsType = [tag: TrackingTag];
        type ResultType = boolean;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace hasTabSection {
        const channel = Channel.HasTabSection;
        type ArgsType = [tag: TrackingTag];
        type ResultType = boolean;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace hasTabButton {
        const channel = Channel.HasTabButton;
        type ArgsType = [tag: TrackingTag];
        type ResultType = boolean;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace hasTabButtonItem {
        const channel = Channel.HasTabButtonItem;
        type ArgsType = [tag: TrackingTag];
        type ResultType = boolean;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace getTabTags {
        const channel = Channel.GetTabTags;
        type ArgsType = [];
        type ResultType = TrackingTag[];
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace getTabSectionTags {
        const channel = Channel.GetTabSectionTags;
        type ArgsType = [tabTag: TrackingTag];
        type ResultType = TrackingTag[];
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace getTabButtonTags {
        const channel = Channel.GetTabButtonTags;
        type ArgsType = [tabOrSectionTag: TrackingTag];
        type ResultType = TrackingTag[];
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace getTabButtonItemTags {
        const channel = Channel.GetTabButtonItemTags;
        type ArgsType = [buttonOrItemTag: TrackingTag];
        type ResultType = TrackingTag[];
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace replaceTabs {
        const channel = Channel.ReplaceTabs;
        type ArgsType = [tabsInfo: Map<TrackingTag, ICPTabInfo>];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabsReplaced {
        const channel = Channel.OnTabsReplaced;
        namespace listener {
            type ArgsType = [tabTags: Map<TrackingTag, TrackingTag>];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace replaceTabSections {
        const channel = Channel.ReplaceTabSections;
        type ArgsType = [sectionsInfo: Map<TrackingTag, ICPTabSectionInfo>];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabSectionsReplaced {
        const channel = Channel.OnTabSectionsReplaced;
        namespace listener {
            type ArgsType = [sectionTags: Map<TrackingTag, TrackingTag>];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace replaceTabButtons {
        const channel = Channel.ReplaceTabButtons;
        type ArgsType = [buttonsInfo: Map<TrackingTag, ICPTabButtonInfo>];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabButtonsReplaced {
        const channel = Channel.OnTabButtonsReplaced;
        namespace listener {
            type ArgsType = [buttonTags: Map<TrackingTag, TrackingTag>];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace replaceTabButtonItems {
        const channel = Channel.ReplaceTabButtonItems;
        type ArgsType = [itemsInfo: Map<TrackingTag, ICPTabButtonItemInfo>];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabButtonItemsReplaced {
        const channel = Channel.OnTabButtonItemsReplaced;
        namespace listener {
            type ArgsType = [itemTags: Map<TrackingTag, TrackingTag>];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace removeTabs {
        const channel = Channel.RemoveTabs;
        type ArgsType = [...tags: TrackingTag[]];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabsRemoved {
        const channel = Channel.OnTabsRemoved;
        namespace listener {
            type ArgsType = [...tags: TrackingTag[]];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace removeTabSections {
        const channel = Channel.RemoveTabSections;
        type ArgsType = [...tags: TrackingTag[]];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabSectionsRemoved {
        const channel = Channel.OnTabSectionsRemoved;
        namespace listener {
            type ArgsType = [...tags: TrackingTag[]];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace removeTabButtons {
        const channel = Channel.RemoveTabButtons;
        type ArgsType = [...tags: TrackingTag[]];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabButtonsRemoved {
        const channel = Channel.OnTabButtonsRemoved;
        namespace listener {
            type ArgsType = [...tags: TrackingTag[]];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace removeTabButtonItems {
        const channel = Channel.RemoveTabButtonItems;
        type ArgsType = [...tags: TrackingTag[]];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabButtonItemsRemoved {
        const channel = Channel.OnTabButtonItemsRemoved;
        namespace listener {
            type ArgsType = [...tags: TrackingTag[]];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace selectTab {
        const channel = Channel.SelectTab;
        type ArgsType = [tag: TrackingTag];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace selectTabSection {
        const channel = Channel.SelectTabSection;
        type ArgsType = [tag: TrackingTag];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace getSelectedTabTag {
        const channel = Channel.GetSelectedTabTag;
        type ArgsType = [];
        type ResultType = TrackingTag | undefined;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace getSelectedTabIndex {
        const channel = Channel.GetSelectedTabIndex;
        type ArgsType = [];
        type ResultType = number | undefined;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace getSelectedTabSectionTag {
        const channel = Channel.GetSelectedTabSectionTag;
        type ArgsType = [];
        type ResultType = TrackingTag | undefined;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace getSelectedTabSectionIndex {
        const channel = Channel.GetSelectedTabSectionIndex;
        type ArgsType = [];
        type ResultType = number | undefined;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace getTabIndex {
        const channel = Channel.GetTabIndex;
        type ArgsType = [tag: TrackingTag];
        type ResultType = number | undefined;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace getTabSectionIndex {
        const channel = Channel.GetTabSectionIndex;
        type ArgsType = [tag: TrackingTag];
        type ResultType = number | undefined;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace getTabButtonIndex {
        const channel = Channel.GetTabButtonIndex;
        type ArgsType = [tag: TrackingTag];
        type ResultType = number | undefined;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace getTabButtonItemIndex {
        const channel = Channel.GetTabButtonItemIndex;
        type ArgsType = [tag: TrackingTag];
        type ResultType = number | undefined;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
}
