import { Api } from '../interfaces/i_api';
import { ApiInfoType } from '../interfaces/i_api_info';
export var controlPanelApiInfo;
(function (controlPanelApiInfo) {
    controlPanelApiInfo.api = Api.ControlPanel;
    controlPanelApiInfo.apiInfoType = ApiInfoType.Main;
    let Channel;
    (function (Channel) {
        Channel["OnGetInitialTabs"] = "controlPanelApi.onGetInitialTabs";
        Channel["SetTabs"] = "controlPanelApi.setTabs";
        Channel["OnTabsSet"] = "controlPanelApi.onTabsSet";
        Channel["SetTabSections"] = "controlPanelApi.setTabSections";
        Channel["OnTabSectionsSet"] = "controlPanelApi.onTabSectionsSet";
        Channel["SetTabButtons"] = "controlPanelApi.setTabButtons";
        Channel["OnTabButtonsSet"] = "controlPanelApi.onTabButtonsSet";
        Channel["SetTabButtonItems"] = "controlPanelApi.setTabButtonItems";
        Channel["OnTabButtonItemsSet"] = "controlPanelApi.onTabButtonItemsSet";
        Channel["AddTabs"] = "controlPanelApi.addTabs";
        Channel["OnTabsAdded"] = "controlPanelApi.onTabsAdded";
        Channel["AddTabSections"] = "controlPanelApi.addTabSections";
        Channel["OnTabSectionsAdded"] = "controlPanelApi.onTabSectionsAdded";
        Channel["AddTabButtons"] = "controlPanelApi.addTabButtons";
        Channel["OnTabButtonsAdded"] = "controlPanelApi.onTabButtonsAdded";
        Channel["AddTabButtonItems"] = "controlPanelApi.addTabButtonItems";
        Channel["OnTabButtonItemsAdded"] = "controlPanelApi.onTabButtonItemsAdded";
        Channel["InsertTabs"] = "controlPanelApi.insertTabs";
        Channel["OnTabsInserted"] = "controlPanelApi.onTabsInserted";
        Channel["InsertTabSections"] = "controlPanelApi.insertTabSections";
        Channel["OnTabSectionsInserted"] = "controlPanelApi.onTabSectionsInserted";
        Channel["InsertTabButtons"] = "controlPanelApi.insertTabButtons";
        Channel["OnTabButtonsInserted"] = "controlPanelApi.onTabButtonsInserted";
        Channel["InsertTabButtonItems"] = "controlPanelApi.insertTabButtonItems";
        Channel["OnTabButtonItemsInserted"] = "controlPanelApi.onTabButtonItemsInserted";
        Channel["HasTab"] = "controlPanelApi.hasTab";
        Channel["HasTabSection"] = "controlPanelApi.hasTabSection";
        Channel["HasTabButton"] = "controlPanelApi.hasTabButton";
        Channel["HasTabButtonItem"] = "controlPanelApi.hasTabButtonItem";
        Channel["GetTabTags"] = "controlPanelApi.getTabTags";
        Channel["GetTabSectionTags"] = "controlPanelApi.getTabSectionTags";
        Channel["GetTabButtonTags"] = "controlPanelApi.getTabButtonTags";
        Channel["GetTabButtonItemTags"] = "controlPanelApi.getTabButtonItemTags";
        Channel["ReplaceTabs"] = "controlPanelApi.replaceTabs";
        Channel["OnTabsReplaced"] = "controlPanelApi.onTabsReplaced";
        Channel["ReplaceTabSections"] = "controlPanelApi.replaceTabSections";
        Channel["OnTabSectionsReplaced"] = "controlPanelApi.onTabSectionsReplaced";
        Channel["ReplaceTabButtons"] = "controlPanelApi.replaceTabButtons";
        Channel["OnTabButtonsReplaced"] = "controlPanelApi.onTabButtonsReplaced";
        Channel["ReplaceTabButtonItems"] = "controlPanelApi.replaceTabButtonItems";
        Channel["OnTabButtonItemsReplaced"] = "controlPanelApi.onTabButtonItemsReplaced";
        Channel["RemoveTabs"] = "controlPanelApi.removeTabs";
        Channel["OnTabsRemoved"] = "controlPanelApi.onTabsRemoved";
        Channel["RemoveTabSections"] = "controlPanelApi.removeTabSections";
        Channel["OnTabSectionsRemoved"] = "controlPanelApi.onTabSectionsRemoved";
        Channel["RemoveTabButtons"] = "controlPanelApi.removeTabButtons";
        Channel["OnTabButtonsRemoved"] = "controlPanelApi.onTabButtonsRemoved";
        Channel["RemoveTabButtonItems"] = "controlPanelApi.removeTabButtonItems";
        Channel["OnTabButtonItemsRemoved"] = "controlPanelApi.onTabButtonItemsRemoved";
        Channel["SelectTab"] = "controlPanelApi.selectTab";
        Channel["SelectTabSection"] = "controlPanelApi.selectTabSection";
        Channel["GetSelectedTabTag"] = "controlPanelApi.getSelectedTabTag";
        Channel["GetSelectedTabIndex"] = "controlPanelApi.getSelectedTabIndex";
        Channel["GetSelectedTabSectionTag"] = "controlPanelApi.getSelectedTabSectionTag";
        Channel["GetSelectedTabSectionIndex"] = "controlPanelApi.getSelectedTabSectionIndex";
        Channel["GetTabIndex"] = "controlPanelApi.getTabIndex";
        Channel["GetTabSectionIndex"] = "controlPanelApi.getTabSectionIndex";
        Channel["GetTabButtonIndex"] = "controlPanelApi.getTabButtonIndex";
        Channel["GetTabButtonItemIndex"] = "controlPanelApi.getTabButtonItemIndex";
    })(Channel = controlPanelApiInfo.Channel || (controlPanelApiInfo.Channel = {}));
    let onGetInitialTabs;
    (function (onGetInitialTabs) {
        onGetInitialTabs.channel = Channel.OnGetInitialTabs;
    })(onGetInitialTabs = controlPanelApiInfo.onGetInitialTabs || (controlPanelApiInfo.onGetInitialTabs = {}));
    let setTabs;
    (function (setTabs) {
        setTabs.channel = Channel.SetTabs;
    })(setTabs = controlPanelApiInfo.setTabs || (controlPanelApiInfo.setTabs = {}));
    let onTabsSet;
    (function (onTabsSet) {
        onTabsSet.channel = Channel.OnTabsSet;
    })(onTabsSet = controlPanelApiInfo.onTabsSet || (controlPanelApiInfo.onTabsSet = {}));
    let setTabSections;
    (function (setTabSections) {
        setTabSections.channel = Channel.SetTabSections;
    })(setTabSections = controlPanelApiInfo.setTabSections || (controlPanelApiInfo.setTabSections = {}));
    let onTabSectionsSet;
    (function (onTabSectionsSet) {
        onTabSectionsSet.channel = Channel.OnTabSectionsSet;
    })(onTabSectionsSet = controlPanelApiInfo.onTabSectionsSet || (controlPanelApiInfo.onTabSectionsSet = {}));
    let setTabButtons;
    (function (setTabButtons) {
        setTabButtons.channel = Channel.SetTabButtons;
    })(setTabButtons = controlPanelApiInfo.setTabButtons || (controlPanelApiInfo.setTabButtons = {}));
    let onTabButtonsSet;
    (function (onTabButtonsSet) {
        onTabButtonsSet.channel = Channel.OnTabButtonsSet;
    })(onTabButtonsSet = controlPanelApiInfo.onTabButtonsSet || (controlPanelApiInfo.onTabButtonsSet = {}));
    let setTabButtonItems;
    (function (setTabButtonItems) {
        setTabButtonItems.channel = Channel.SetTabButtonItems;
    })(setTabButtonItems = controlPanelApiInfo.setTabButtonItems || (controlPanelApiInfo.setTabButtonItems = {}));
    let onTabButtonItemsSet;
    (function (onTabButtonItemsSet) {
        onTabButtonItemsSet.channel = Channel.OnTabButtonItemsSet;
    })(onTabButtonItemsSet = controlPanelApiInfo.onTabButtonItemsSet || (controlPanelApiInfo.onTabButtonItemsSet = {}));
    let addTabs;
    (function (addTabs) {
        addTabs.channel = Channel.AddTabs;
    })(addTabs = controlPanelApiInfo.addTabs || (controlPanelApiInfo.addTabs = {}));
    let onTabsAdded;
    (function (onTabsAdded) {
        onTabsAdded.channel = Channel.OnTabsAdded;
    })(onTabsAdded = controlPanelApiInfo.onTabsAdded || (controlPanelApiInfo.onTabsAdded = {}));
    let addTabSections;
    (function (addTabSections) {
        addTabSections.channel = Channel.AddTabSections;
    })(addTabSections = controlPanelApiInfo.addTabSections || (controlPanelApiInfo.addTabSections = {}));
    let onTabSectionsAdded;
    (function (onTabSectionsAdded) {
        onTabSectionsAdded.channel = Channel.OnTabSectionsAdded;
    })(onTabSectionsAdded = controlPanelApiInfo.onTabSectionsAdded || (controlPanelApiInfo.onTabSectionsAdded = {}));
    let addTabButtons;
    (function (addTabButtons) {
        addTabButtons.channel = Channel.AddTabButtons;
    })(addTabButtons = controlPanelApiInfo.addTabButtons || (controlPanelApiInfo.addTabButtons = {}));
    let onTabButtonsAdded;
    (function (onTabButtonsAdded) {
        onTabButtonsAdded.channel = Channel.OnTabButtonsAdded;
    })(onTabButtonsAdded = controlPanelApiInfo.onTabButtonsAdded || (controlPanelApiInfo.onTabButtonsAdded = {}));
    let addTabButtonItems;
    (function (addTabButtonItems) {
        addTabButtonItems.channel = Channel.AddTabButtonItems;
    })(addTabButtonItems = controlPanelApiInfo.addTabButtonItems || (controlPanelApiInfo.addTabButtonItems = {}));
    let onTabButtonItemsAdded;
    (function (onTabButtonItemsAdded) {
        onTabButtonItemsAdded.channel = Channel.OnTabButtonItemsAdded;
    })(onTabButtonItemsAdded = controlPanelApiInfo.onTabButtonItemsAdded || (controlPanelApiInfo.onTabButtonItemsAdded = {}));
    let insertTabs;
    (function (insertTabs) {
        insertTabs.channel = Channel.InsertTabs;
    })(insertTabs = controlPanelApiInfo.insertTabs || (controlPanelApiInfo.insertTabs = {}));
    let onTabsInserted;
    (function (onTabsInserted) {
        onTabsInserted.channel = Channel.OnTabsInserted;
    })(onTabsInserted = controlPanelApiInfo.onTabsInserted || (controlPanelApiInfo.onTabsInserted = {}));
    let insertTabSections;
    (function (insertTabSections) {
        insertTabSections.channel = Channel.InsertTabSections;
    })(insertTabSections = controlPanelApiInfo.insertTabSections || (controlPanelApiInfo.insertTabSections = {}));
    let onTabSectionsInserted;
    (function (onTabSectionsInserted) {
        onTabSectionsInserted.channel = Channel.OnTabSectionsInserted;
    })(onTabSectionsInserted = controlPanelApiInfo.onTabSectionsInserted || (controlPanelApiInfo.onTabSectionsInserted = {}));
    let insertTabButtons;
    (function (insertTabButtons) {
        insertTabButtons.channel = Channel.InsertTabButtons;
    })(insertTabButtons = controlPanelApiInfo.insertTabButtons || (controlPanelApiInfo.insertTabButtons = {}));
    let onTabButtonsInserted;
    (function (onTabButtonsInserted) {
        onTabButtonsInserted.channel = Channel.OnTabButtonsInserted;
    })(onTabButtonsInserted = controlPanelApiInfo.onTabButtonsInserted || (controlPanelApiInfo.onTabButtonsInserted = {}));
    let insertTabButtonItems;
    (function (insertTabButtonItems) {
        insertTabButtonItems.channel = Channel.InsertTabButtonItems;
    })(insertTabButtonItems = controlPanelApiInfo.insertTabButtonItems || (controlPanelApiInfo.insertTabButtonItems = {}));
    let onTabButtonItemsInserted;
    (function (onTabButtonItemsInserted) {
        onTabButtonItemsInserted.channel = Channel.OnTabButtonItemsInserted;
    })(onTabButtonItemsInserted = controlPanelApiInfo.onTabButtonItemsInserted || (controlPanelApiInfo.onTabButtonItemsInserted = {}));
    let hasTab;
    (function (hasTab) {
        hasTab.channel = Channel.HasTab;
    })(hasTab = controlPanelApiInfo.hasTab || (controlPanelApiInfo.hasTab = {}));
    let hasTabSection;
    (function (hasTabSection) {
        hasTabSection.channel = Channel.HasTabSection;
    })(hasTabSection = controlPanelApiInfo.hasTabSection || (controlPanelApiInfo.hasTabSection = {}));
    let hasTabButton;
    (function (hasTabButton) {
        hasTabButton.channel = Channel.HasTabButton;
    })(hasTabButton = controlPanelApiInfo.hasTabButton || (controlPanelApiInfo.hasTabButton = {}));
    let hasTabButtonItem;
    (function (hasTabButtonItem) {
        hasTabButtonItem.channel = Channel.HasTabButtonItem;
    })(hasTabButtonItem = controlPanelApiInfo.hasTabButtonItem || (controlPanelApiInfo.hasTabButtonItem = {}));
    let getTabTags;
    (function (getTabTags) {
        getTabTags.channel = Channel.GetTabTags;
    })(getTabTags = controlPanelApiInfo.getTabTags || (controlPanelApiInfo.getTabTags = {}));
    let getTabSectionTags;
    (function (getTabSectionTags) {
        getTabSectionTags.channel = Channel.GetTabSectionTags;
    })(getTabSectionTags = controlPanelApiInfo.getTabSectionTags || (controlPanelApiInfo.getTabSectionTags = {}));
    let getTabButtonTags;
    (function (getTabButtonTags) {
        getTabButtonTags.channel = Channel.GetTabButtonTags;
    })(getTabButtonTags = controlPanelApiInfo.getTabButtonTags || (controlPanelApiInfo.getTabButtonTags = {}));
    let getTabButtonItemTags;
    (function (getTabButtonItemTags) {
        getTabButtonItemTags.channel = Channel.GetTabButtonItemTags;
    })(getTabButtonItemTags = controlPanelApiInfo.getTabButtonItemTags || (controlPanelApiInfo.getTabButtonItemTags = {}));
    let replaceTabs;
    (function (replaceTabs) {
        replaceTabs.channel = Channel.ReplaceTabs;
    })(replaceTabs = controlPanelApiInfo.replaceTabs || (controlPanelApiInfo.replaceTabs = {}));
    let onTabsReplaced;
    (function (onTabsReplaced) {
        onTabsReplaced.channel = Channel.OnTabsReplaced;
    })(onTabsReplaced = controlPanelApiInfo.onTabsReplaced || (controlPanelApiInfo.onTabsReplaced = {}));
    let replaceTabSections;
    (function (replaceTabSections) {
        replaceTabSections.channel = Channel.ReplaceTabSections;
    })(replaceTabSections = controlPanelApiInfo.replaceTabSections || (controlPanelApiInfo.replaceTabSections = {}));
    let onTabSectionsReplaced;
    (function (onTabSectionsReplaced) {
        onTabSectionsReplaced.channel = Channel.OnTabSectionsReplaced;
    })(onTabSectionsReplaced = controlPanelApiInfo.onTabSectionsReplaced || (controlPanelApiInfo.onTabSectionsReplaced = {}));
    let replaceTabButtons;
    (function (replaceTabButtons) {
        replaceTabButtons.channel = Channel.ReplaceTabButtons;
    })(replaceTabButtons = controlPanelApiInfo.replaceTabButtons || (controlPanelApiInfo.replaceTabButtons = {}));
    let onTabButtonsReplaced;
    (function (onTabButtonsReplaced) {
        onTabButtonsReplaced.channel = Channel.OnTabButtonsReplaced;
    })(onTabButtonsReplaced = controlPanelApiInfo.onTabButtonsReplaced || (controlPanelApiInfo.onTabButtonsReplaced = {}));
    let replaceTabButtonItems;
    (function (replaceTabButtonItems) {
        replaceTabButtonItems.channel = Channel.ReplaceTabButtonItems;
    })(replaceTabButtonItems = controlPanelApiInfo.replaceTabButtonItems || (controlPanelApiInfo.replaceTabButtonItems = {}));
    let onTabButtonItemsReplaced;
    (function (onTabButtonItemsReplaced) {
        onTabButtonItemsReplaced.channel = Channel.OnTabButtonItemsReplaced;
    })(onTabButtonItemsReplaced = controlPanelApiInfo.onTabButtonItemsReplaced || (controlPanelApiInfo.onTabButtonItemsReplaced = {}));
    let removeTabs;
    (function (removeTabs) {
        removeTabs.channel = Channel.RemoveTabs;
    })(removeTabs = controlPanelApiInfo.removeTabs || (controlPanelApiInfo.removeTabs = {}));
    let onTabsRemoved;
    (function (onTabsRemoved) {
        onTabsRemoved.channel = Channel.OnTabsRemoved;
    })(onTabsRemoved = controlPanelApiInfo.onTabsRemoved || (controlPanelApiInfo.onTabsRemoved = {}));
    let removeTabSections;
    (function (removeTabSections) {
        removeTabSections.channel = Channel.RemoveTabSections;
    })(removeTabSections = controlPanelApiInfo.removeTabSections || (controlPanelApiInfo.removeTabSections = {}));
    let onTabSectionsRemoved;
    (function (onTabSectionsRemoved) {
        onTabSectionsRemoved.channel = Channel.OnTabSectionsRemoved;
    })(onTabSectionsRemoved = controlPanelApiInfo.onTabSectionsRemoved || (controlPanelApiInfo.onTabSectionsRemoved = {}));
    let removeTabButtons;
    (function (removeTabButtons) {
        removeTabButtons.channel = Channel.RemoveTabButtons;
    })(removeTabButtons = controlPanelApiInfo.removeTabButtons || (controlPanelApiInfo.removeTabButtons = {}));
    let onTabButtonsRemoved;
    (function (onTabButtonsRemoved) {
        onTabButtonsRemoved.channel = Channel.OnTabButtonsRemoved;
    })(onTabButtonsRemoved = controlPanelApiInfo.onTabButtonsRemoved || (controlPanelApiInfo.onTabButtonsRemoved = {}));
    let removeTabButtonItems;
    (function (removeTabButtonItems) {
        removeTabButtonItems.channel = Channel.RemoveTabButtonItems;
    })(removeTabButtonItems = controlPanelApiInfo.removeTabButtonItems || (controlPanelApiInfo.removeTabButtonItems = {}));
    let onTabButtonItemsRemoved;
    (function (onTabButtonItemsRemoved) {
        onTabButtonItemsRemoved.channel = Channel.OnTabButtonItemsRemoved;
    })(onTabButtonItemsRemoved = controlPanelApiInfo.onTabButtonItemsRemoved || (controlPanelApiInfo.onTabButtonItemsRemoved = {}));
    let selectTab;
    (function (selectTab) {
        selectTab.channel = Channel.SelectTab;
    })(selectTab = controlPanelApiInfo.selectTab || (controlPanelApiInfo.selectTab = {}));
    let selectTabSection;
    (function (selectTabSection) {
        selectTabSection.channel = Channel.SelectTabSection;
    })(selectTabSection = controlPanelApiInfo.selectTabSection || (controlPanelApiInfo.selectTabSection = {}));
    let getSelectedTabTag;
    (function (getSelectedTabTag) {
        getSelectedTabTag.channel = Channel.GetSelectedTabTag;
    })(getSelectedTabTag = controlPanelApiInfo.getSelectedTabTag || (controlPanelApiInfo.getSelectedTabTag = {}));
    let getSelectedTabIndex;
    (function (getSelectedTabIndex) {
        getSelectedTabIndex.channel = Channel.GetSelectedTabIndex;
    })(getSelectedTabIndex = controlPanelApiInfo.getSelectedTabIndex || (controlPanelApiInfo.getSelectedTabIndex = {}));
    let getSelectedTabSectionTag;
    (function (getSelectedTabSectionTag) {
        getSelectedTabSectionTag.channel = Channel.GetSelectedTabSectionTag;
    })(getSelectedTabSectionTag = controlPanelApiInfo.getSelectedTabSectionTag || (controlPanelApiInfo.getSelectedTabSectionTag = {}));
    let getSelectedTabSectionIndex;
    (function (getSelectedTabSectionIndex) {
        getSelectedTabSectionIndex.channel = Channel.GetSelectedTabSectionIndex;
    })(getSelectedTabSectionIndex = controlPanelApiInfo.getSelectedTabSectionIndex || (controlPanelApiInfo.getSelectedTabSectionIndex = {}));
    let getTabIndex;
    (function (getTabIndex) {
        getTabIndex.channel = Channel.GetTabIndex;
    })(getTabIndex = controlPanelApiInfo.getTabIndex || (controlPanelApiInfo.getTabIndex = {}));
    let getTabSectionIndex;
    (function (getTabSectionIndex) {
        getTabSectionIndex.channel = Channel.GetTabSectionIndex;
    })(getTabSectionIndex = controlPanelApiInfo.getTabSectionIndex || (controlPanelApiInfo.getTabSectionIndex = {}));
    let getTabButtonIndex;
    (function (getTabButtonIndex) {
        getTabButtonIndex.channel = Channel.GetTabButtonIndex;
    })(getTabButtonIndex = controlPanelApiInfo.getTabButtonIndex || (controlPanelApiInfo.getTabButtonIndex = {}));
    let getTabButtonItemIndex;
    (function (getTabButtonItemIndex) {
        getTabButtonItemIndex.channel = Channel.GetTabButtonItemIndex;
    })(getTabButtonItemIndex = controlPanelApiInfo.getTabButtonItemIndex || (controlPanelApiInfo.getTabButtonItemIndex = {}));
})(controlPanelApiInfo || (controlPanelApiInfo = {}));
