import { IpcRendererEvent } from '../classes/electron';
import { controlPanelApiInfo as i } from '../interfaces/i_control_panel_api_info';
import { ApiInfoType } from '../interfaces/i_api_info';
import { ApiListenerId } from '../interfaces/i_api_listener';
export declare namespace controlPanelApiInfoPreload {
    const api = Api.ControlPanel;
    const apiInfoType = ApiInfoType.Preload;
    namespace onGetInitialTabs {
        const channel = i.Channel.OnGetInitialTabs;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onGetInitialTabs.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onGetInitialTabs.ListenerType;
        type ArgsType = [listener: ListenerType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace setTabs {
        const channel = i.Channel.SetTabs;
        type ArgsType = i.setTabs.ArgsType;
        type ResultType = i.setTabs.ResultType;
        type ReturnType = i.setTabs.ReturnType;
        type FunctionType = i.setTabs.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabsSet {
        const channel = i.Channel.OnTabsSet;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabsSet.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabsSet.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace setTabSections {
        const channel = i.Channel.SetTabSections;
        type ArgsType = i.setTabSections.ArgsType;
        type ResultType = i.setTabSections.ResultType;
        type ReturnType = i.setTabSections.ReturnType;
        type FunctionType = i.setTabSections.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabSectionsSet {
        const channel = i.Channel.OnTabSectionsSet;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabSectionsSet.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabSectionsSet.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace setTabButtons {
        const channel = i.Channel.SetTabButtons;
        type ArgsType = i.setTabButtons.ArgsType;
        type ResultType = i.setTabButtons.ResultType;
        type ReturnType = i.setTabButtons.ReturnType;
        type FunctionType = i.setTabButtons.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabButtonsSet {
        const channel = i.Channel.OnTabButtonsSet;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabButtonsSet.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabButtonsSet.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace setTabButtonItems {
        const channel = i.Channel.SetTabButtonItems;
        type ArgsType = i.setTabButtonItems.ArgsType;
        type ResultType = i.setTabButtonItems.ResultType;
        type ReturnType = i.setTabButtonItems.ReturnType;
        type FunctionType = i.setTabButtonItems.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabButtonItemsSet {
        const channel = i.Channel.OnTabButtonItemsSet;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabButtonItemsSet.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabButtonItemsSet.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace addTabs {
        const channel = i.Channel.AddTabs;
        type ArgsType = i.addTabs.ArgsType;
        type ResultType = i.addTabs.ResultType;
        type ReturnType = i.addTabs.ReturnType;
        type FunctionType = i.addTabs.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabsAdded {
        const channel = i.Channel.OnTabsAdded;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabsAdded.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabsAdded.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace addTabSections {
        const channel = i.Channel.AddTabSections;
        type ArgsType = i.addTabSections.ArgsType;
        type ResultType = i.addTabSections.ResultType;
        type ReturnType = i.addTabSections.ReturnType;
        type FunctionType = i.addTabSections.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabSectionsAdded {
        const channel = i.Channel.OnTabSectionsAdded;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabSectionsAdded.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabSectionsAdded.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace addTabButtons {
        const channel = i.Channel.AddTabButtons;
        type ArgsType = i.addTabButtons.ArgsType;
        type ResultType = i.addTabButtons.ResultType;
        type ReturnType = i.addTabButtons.ReturnType;
        type FunctionType = i.addTabButtons.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabButtonsAdded {
        const channel = i.Channel.OnTabButtonsAdded;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabButtonsAdded.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabButtonsAdded.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace addTabButtonItems {
        const channel = i.Channel.AddTabButtonItems;
        type ArgsType = i.addTabButtonItems.ArgsType;
        type ResultType = i.addTabButtonItems.ResultType;
        type ReturnType = i.addTabButtonItems.ReturnType;
        type FunctionType = i.addTabButtonItems.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabButtonItemsAdded {
        const channel = i.Channel.OnTabButtonItemsAdded;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabButtonItemsAdded.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabButtonItemsAdded.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace insertTabs {
        const channel = i.Channel.InsertTabs;
        type ArgsType = i.insertTabs.ArgsType;
        type ResultType = i.insertTabs.ResultType;
        type ReturnType = i.insertTabs.ReturnType;
        type FunctionType = i.insertTabs.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabsInserted {
        const channel = i.Channel.OnTabsInserted;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabsInserted.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabsInserted.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace insertTabSections {
        const channel = i.Channel.InsertTabSections;
        type ArgsType = i.insertTabSections.ArgsType;
        type ResultType = i.insertTabSections.ResultType;
        type ReturnType = i.insertTabSections.ReturnType;
        type FunctionType = i.insertTabSections.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabSectionsInserted {
        const channel = i.Channel.OnTabSectionsInserted;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabSectionsInserted.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabSectionsInserted.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace insertTabButtons {
        const channel = i.Channel.InsertTabButtons;
        type ArgsType = i.insertTabButtons.ArgsType;
        type ResultType = i.insertTabButtons.ResultType;
        type ReturnType = i.insertTabButtons.ReturnType;
        type FunctionType = i.insertTabButtons.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabButtonsInserted {
        const channel = i.Channel.OnTabButtonsInserted;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabButtonsInserted.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabButtonsInserted.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace insertTabButtonItems {
        const channel = i.Channel.InsertTabButtonItems;
        type ArgsType = i.insertTabButtonItems.ArgsType;
        type ResultType = i.insertTabButtonItems.ResultType;
        type ReturnType = i.insertTabButtonItems.ReturnType;
        type FunctionType = i.insertTabButtonItems.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabButtonItemsInserted {
        const channel = i.Channel.OnTabButtonItemsInserted;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabButtonItemsInserted.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabButtonItemsInserted.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace hasTab {
        const channel = i.Channel.HasTab;
        type ArgsType = i.hasTab.ArgsType;
        type ResultType = i.hasTab.ResultType;
        type ReturnType = i.hasTab.ReturnType;
        type FunctionType = i.hasTab.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [hasTab: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace hasTabSection {
        const channel = i.Channel.HasTabSection;
        type ArgsType = i.hasTabSection.ArgsType;
        type ResultType = i.hasTabSection.ResultType;
        type ReturnType = i.hasTabSection.ReturnType;
        type FunctionType = i.hasTabSection.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [hasTabSection: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace hasTabButton {
        const channel = i.Channel.HasTabButton;
        type ArgsType = i.hasTabButton.ArgsType;
        type ResultType = i.hasTabButton.ResultType;
        type ReturnType = i.hasTabButton.ReturnType;
        type FunctionType = i.hasTabButton.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [hasTabButton: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace hasTabButtonItem {
        const channel = i.Channel.HasTabButtonItem;
        type ArgsType = i.hasTabButtonItem.ArgsType;
        type ResultType = i.hasTabButtonItem.ResultType;
        type ReturnType = i.hasTabButtonItem.ReturnType;
        type FunctionType = i.hasTabButtonItem.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [hasTabButtonItem: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace getTabTags {
        const channel = i.Channel.GetTabTags;
        type ArgsType = i.getTabTags.ArgsType;
        type ResultType = i.getTabTags.ResultType;
        type ReturnType = i.getTabTags.ReturnType;
        type FunctionType = i.getTabTags.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [tabTags: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace getTabSectionTags {
        const channel = i.Channel.GetTabSectionTags;
        type ArgsType = i.getTabSectionTags.ArgsType;
        type ResultType = i.getTabSectionTags.ResultType;
        type ReturnType = i.getTabSectionTags.ReturnType;
        type FunctionType = i.getTabSectionTags.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [tabSectionTags: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace getTabButtonTags {
        const channel = i.Channel.GetTabButtonTags;
        type ArgsType = i.getTabButtonTags.ArgsType;
        type ResultType = i.getTabButtonTags.ResultType;
        type ReturnType = i.getTabButtonTags.ReturnType;
        type FunctionType = i.getTabButtonTags.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [tabButtonTags: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace getTabButtonItemTags {
        const channel = i.Channel.GetTabButtonItemTags;
        type ArgsType = i.getTabButtonItemTags.ArgsType;
        type ResultType = i.getTabButtonItemTags.ResultType;
        type ReturnType = i.getTabButtonItemTags.ReturnType;
        type FunctionType = i.getTabButtonItemTags.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [tabButtonItemTags: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace replaceTabs {
        const channel = i.Channel.ReplaceTabs;
        type ArgsType = i.replaceTabs.ArgsType;
        type ResultType = i.replaceTabs.ResultType;
        type ReturnType = i.replaceTabs.ReturnType;
        type FunctionType = i.replaceTabs.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabsReplaced {
        const channel = i.Channel.OnTabsReplaced;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabsReplaced.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabsReplaced.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace replaceTabSections {
        const channel = i.Channel.ReplaceTabSections;
        type ArgsType = i.replaceTabSections.ArgsType;
        type ResultType = i.replaceTabSections.ResultType;
        type ReturnType = i.replaceTabSections.ReturnType;
        type FunctionType = i.replaceTabSections.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabSectionsReplaced {
        const channel = i.Channel.OnTabSectionsReplaced;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabSectionsReplaced.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabSectionsReplaced.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace replaceTabButtons {
        const channel = i.Channel.ReplaceTabButtons;
        type ArgsType = i.replaceTabButtons.ArgsType;
        type ResultType = i.replaceTabButtons.ResultType;
        type ReturnType = i.replaceTabButtons.ReturnType;
        type FunctionType = i.replaceTabButtons.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabButtonsReplaced {
        const channel = i.Channel.OnTabButtonsReplaced;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabButtonsReplaced.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabButtonsReplaced.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace replaceTabButtonItems {
        const channel = i.Channel.ReplaceTabButtonItems;
        type ArgsType = i.replaceTabButtonItems.ArgsType;
        type ResultType = i.replaceTabButtonItems.ResultType;
        type ReturnType = i.replaceTabButtonItems.ReturnType;
        type FunctionType = i.replaceTabButtonItems.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabButtonItemsReplaced {
        const channel = i.Channel.OnTabButtonItemsReplaced;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabButtonItemsReplaced.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabButtonItemsReplaced.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace removeTabs {
        const channel = i.Channel.RemoveTabs;
        type ArgsType = i.removeTabs.ArgsType;
        type ResultType = i.removeTabs.ResultType;
        type ReturnType = i.removeTabs.ReturnType;
        type FunctionType = i.removeTabs.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabsRemoved {
        const channel = i.Channel.OnTabsRemoved;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabsRemoved.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabsRemoved.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace removeTabSections {
        const channel = i.Channel.RemoveTabSections;
        type ArgsType = i.removeTabSections.ArgsType;
        type ResultType = i.removeTabSections.ResultType;
        type ReturnType = i.removeTabSections.ReturnType;
        type FunctionType = i.removeTabSections.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabSectionsRemoved {
        const channel = i.Channel.OnTabSectionsRemoved;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabSectionsRemoved.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabSectionsRemoved.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace removeTabButtons {
        const channel = i.Channel.RemoveTabButtons;
        type ArgsType = i.removeTabButtons.ArgsType;
        type ResultType = i.removeTabButtons.ResultType;
        type ReturnType = i.removeTabButtons.ReturnType;
        type FunctionType = i.removeTabButtons.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabButtonsRemoved {
        const channel = i.Channel.OnTabButtonsRemoved;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabButtonsRemoved.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabButtonsRemoved.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace removeTabButtonItems {
        const channel = i.Channel.RemoveTabButtonItems;
        type ArgsType = i.removeTabButtonItems.ArgsType;
        type ResultType = i.removeTabButtonItems.ResultType;
        type ReturnType = i.removeTabButtonItems.ReturnType;
        type FunctionType = i.removeTabButtonItems.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabButtonItemsRemoved {
        const channel = i.Channel.OnTabButtonItemsRemoved;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabButtonItemsRemoved.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabButtonItemsRemoved.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace selectTab {
        const channel = i.Channel.SelectTab;
        type ArgsType = i.selectTab.ArgsType;
        type ResultType = i.selectTab.ResultType;
        type ReturnType = i.selectTab.ReturnType;
        type FunctionType = i.selectTab.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace selectTabSection {
        const channel = i.Channel.SelectTabSection;
        type ArgsType = i.selectTabSection.ArgsType;
        type ResultType = i.selectTabSection.ResultType;
        type ReturnType = i.selectTabSection.ReturnType;
        type FunctionType = i.selectTabSection.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace getSelectedTabTag {
        const channel = i.Channel.GetSelectedTabTag;
        type ArgsType = i.getSelectedTabTag.ArgsType;
        type ResultType = i.getSelectedTabTag.ResultType;
        type ReturnType = i.getSelectedTabTag.ReturnType;
        type FunctionType = i.getSelectedTabTag.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [selectedTabInfo: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace getSelectedTabIndex {
        const channel = i.Channel.GetSelectedTabIndex;
        type ArgsType = i.getSelectedTabIndex.ArgsType;
        type ResultType = i.getSelectedTabIndex.ResultType;
        type ReturnType = i.getSelectedTabIndex.ReturnType;
        type FunctionType = i.getSelectedTabIndex.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [selectedTabInfo: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace getSelectedTabSectionTag {
        const channel = i.Channel.GetSelectedTabSectionTag;
        type ArgsType = i.getSelectedTabSectionTag.ArgsType;
        type ResultType = i.getSelectedTabSectionTag.ResultType;
        type ReturnType = i.getSelectedTabSectionTag.ReturnType;
        type FunctionType = i.getSelectedTabSectionTag.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [selectedTabSectionInfo: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace getSelectedTabSectionIndex {
        const channel = i.Channel.GetSelectedTabSectionIndex;
        type ArgsType = i.getSelectedTabSectionIndex.ArgsType;
        type ResultType = i.getSelectedTabSectionIndex.ResultType;
        type ReturnType = i.getSelectedTabSectionIndex.ReturnType;
        type FunctionType = i.getSelectedTabSectionIndex.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [selectedTabSectionInfo: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace getTabIndex {
        const channel = i.Channel.GetTabIndex;
        type ArgsType = i.getTabIndex.ArgsType;
        type ResultType = i.getTabIndex.ResultType;
        type ReturnType = i.getTabIndex.ReturnType;
        type FunctionType = i.getTabIndex.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [tabIndex: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace getTabSectionIndex {
        const channel = i.Channel.GetTabSectionIndex;
        type ArgsType = i.getTabSectionIndex.ArgsType;
        type ResultType = i.getTabSectionIndex.ResultType;
        type ReturnType = i.getTabSectionIndex.ReturnType;
        type FunctionType = i.getTabSectionIndex.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [tabSectionIndex: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace getTabButtonIndex {
        const channel = i.Channel.GetTabButtonIndex;
        type ArgsType = i.getTabButtonIndex.ArgsType;
        type ResultType = i.getTabButtonIndex.ResultType;
        type ReturnType = i.getTabButtonIndex.ReturnType;
        type FunctionType = i.getTabButtonIndex.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [tabButtonIndex: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace getTabButtonItemIndex {
        const channel = i.Channel.GetTabButtonItemIndex;
        type ArgsType = i.getTabButtonItemIndex.ArgsType;
        type ResultType = i.getTabButtonItemIndex.ResultType;
        type ReturnType = i.getTabButtonItemIndex.ReturnType;
        type FunctionType = i.getTabButtonItemIndex.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [tabButtonItemIndex: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
}
