import { IExtEvent } from '../interfaces/i_ext_event';
import { ICPTabButtonItemsDelegate, IExtCPTabButtonItemsDelegate } from '../interfaces/i_cp_tab_button_items_delegate';
import { EntityType } from '../interfaces/i_entity';
import { IExtPopup, IIntPopup } from '../interfaces/i_popup';
import { IExtEntity } from '../interfaces/i_ext_entity';
import { IDestructable } from '../interfaces/i_destructable';
import { CPTabId } from '../interfaces/i_cp_tab';
import { CPTabSectionId } from '../interfaces/i_cp_tab_section';
import { IResettable } from '../interfaces/i_resettable';
export type CPTabButtonId = string;
export declare enum CPTabButtonType {
    Event = "event",
    Items = "items",
    Popup = "popup"
}
export interface ICPTabButtonBase extends IDestructable, IResettable {
    readonly entityType: EntityType;
    readonly id: CPTabButtonId;
    readonly title: string;
    readonly iconContent?: string;
    readonly parentTabOrSectionId: CPTabId | CPTabSectionId;
    readonly type: CPTabButtonType;
    readonly isSelected: boolean;
    readonly isDisabled: boolean;
    readonly createdDate: Date;
}
export interface ICPTabButtonClosableOnSelect {
    readonly shouldCloseOnSelect: boolean;
}
export declare enum IntCPTabButtonEventType {
    AddExtension = 0
}
export interface IIntCPTabButtonBase extends ICPTabButtonBase {
    readonly entityType: EntityType.Int;
}
export interface IIntCPTabButtonWithEvent extends IIntCPTabButtonBase, ICPTabButtonClosableOnSelect {
    readonly type: CPTabButtonType.Event;
    readonly eventType: IntCPTabButtonEventType;
}
export interface IIntCPTabButtonWithItems extends IIntCPTabButtonBase, ICPTabButtonItemsDelegate {
    readonly type: CPTabButtonType.Items;
}
export interface IIntCPTabButtonWithPopup extends IIntCPTabButtonBase {
    readonly type: CPTabButtonType.Popup;
    readonly popup: IIntPopup;
}
export type IIntCPTabButton = IIntCPTabButtonWithEvent | IIntCPTabButtonWithItems | IIntCPTabButtonWithPopup;
export interface IExtCPTabButtonBase extends ICPTabButtonBase, IExtEntity {
    readonly entityType: EntityType.Ext;
}
export interface IExtCPTabButtonWithEvent extends IExtCPTabButtonBase, ICPTabButtonClosableOnSelect {
    readonly type: CPTabButtonType.Event;
    readonly event: IExtEvent;
}
export interface IExtCPTabButtonWithItems extends IExtCPTabButtonBase, IExtCPTabButtonItemsDelegate {
    readonly type: CPTabButtonType.Items;
}
export interface IExtCPTabButtonWithPopup extends IExtCPTabButtonBase {
    readonly type: CPTabButtonType.Popup;
    readonly popup: IExtPopup;
}
export type IExtCPTabButton = IExtCPTabButtonWithEvent | IExtCPTabButtonWithItems | IExtCPTabButtonWithPopup;
export type ICPTabButton = IIntCPTabButton | IExtCPTabButton;
export type ICPTabButtonWithItems = IIntCPTabButtonWithItems | IExtCPTabButtonWithItems;
