import { TrackingTag } from '../interfaces/i_tracking_tag';
import { IPopupInfo } from '../interfaces/i_popup_info';
import { IExtEvent } from '../interfaces/i_ext_event';
import { ICPTabButtonItemInfo } from '../interfaces/i_cp_tab_button_item_info';
export declare enum CPTabButtonInfoType {
    Event = "event",
    Items = "items",
    Popup = "popup"
}
export interface ICPTabButtonInfoBase {
    readonly tag: TrackingTag;
    readonly type: CPTabButtonInfoType;
    readonly title: string;
    readonly iconPath?: string;
    readonly isSelected?: boolean;
    readonly isDisabled?: boolean;
}
export interface ICPTabButtonClosableOnSelectInfo {
    readonly shouldCloseOnSelect?: boolean;
}
export interface ICPTabButtonWithEventInfo extends ICPTabButtonInfoBase, ICPTabButtonClosableOnSelectInfo {
    readonly type: CPTabButtonInfoType.Event;
    readonly event: IExtEvent;
}
export interface ICPTabButtonWithItemsInfo extends ICPTabButtonInfoBase, ICPTabButtonClosableOnSelectInfo {
    readonly type: CPTabButtonInfoType.Items;
    readonly itemsInfo: ICPTabButtonItemInfo[];
}
export interface ICPTabButtonWithPopupInfo extends ICPTabButtonInfoBase {
    readonly type: CPTabButtonInfoType.Popup;
    readonly popupInfo: IPopupInfo;
}
export type ICPTabButtonInfo = ICPTabButtonWithEventInfo | ICPTabButtonWithItemsInfo | ICPTabButtonWithPopupInfo;
