import { IExtCPTabButtonItemsDelegate, ICPTabButtonItemsDelegate } from '../interfaces/i_cp_tab_button_items_delegate';
import { EntityType } from '../interfaces/i_entity';
import { IExtPopup, IIntPopup } from '../interfaces/i_popup';
import { IExtEvent } from '../interfaces/i_ext_event';
import { IExtEntity } from '../interfaces/i_ext_entity';
import { IDestructable } from '../interfaces/i_destructable';
import { CPTabButtonId } from '../interfaces/i_cp_tab_button';
import { IResettable } from '../interfaces/i_resettable';
export type CPTabButtonItemId = string;
export declare enum CPTabButtonItemType {
    Event = "event",
    InfoIcon = "infoIcon",
    InfoText = "infoText",
    Items = "items",
    Popup = "popup"
}
export interface ICPTabButtonItemBase extends IDestructable, IResettable {
    readonly entityType: EntityType;
    readonly id: CPTabButtonItemId;
    readonly title: string;
    readonly iconContent?: string;
    readonly parentButtonOrItemId: CPTabButtonId | CPTabButtonItemId;
    readonly type: CPTabButtonItemType;
    readonly isSelected: boolean;
    readonly isDisabled: boolean;
    readonly createdDate: Date;
}
interface ICPTabButtonItemClosableOnSelect {
    readonly shouldCloseOnSelect: boolean;
}
export declare enum IntCPTabButtonItemEventType {
}
export interface IIntCPTabButtonItemBase extends ICPTabButtonItemBase {
    readonly entityType: EntityType.Int;
}
export interface IIntCPTabButtonItemWithEvent extends IIntCPTabButtonItemBase, ICPTabButtonItemClosableOnSelect {
    readonly type: CPTabButtonItemType.Event;
    readonly eventType: IntCPTabButtonItemEventType;
}
export interface IIntCPTabButtonItemWithItems extends IIntCPTabButtonItemBase, ICPTabButtonItemsDelegate {
    readonly type: CPTabButtonItemType.Items;
}
export interface IIntCPTabButtonItemWithInfoIcon extends IIntCPTabButtonItemBase, ICPTabButtonItemClosableOnSelect {
    readonly type: CPTabButtonItemType.InfoIcon;
    readonly eventType: IntCPTabButtonItemEventType;
    readonly infoIconContent: string;
}
export interface IIntCPTabButtonItemWithInfoText extends IIntCPTabButtonItemBase, ICPTabButtonItemClosableOnSelect {
    readonly type: CPTabButtonItemType.InfoText;
    readonly eventType: IntCPTabButtonItemEventType;
    readonly infoText: string;
}
export interface IIntCPTabButtonItemWithPopup extends IIntCPTabButtonItemBase {
    readonly type: CPTabButtonItemType.Popup;
    readonly popup: IIntPopup;
}
export type IIntCPTabButtonItem = IIntCPTabButtonItemWithEvent | IIntCPTabButtonItemWithItems | IIntCPTabButtonItemWithInfoIcon | IIntCPTabButtonItemWithInfoText | IIntCPTabButtonItemWithPopup;
export interface IExtCPTabButtonItemBase extends ICPTabButtonItemBase, IExtEntity {
    readonly entityType: EntityType.Ext;
}
export interface IExtCPTabButtonItemWithEvent extends IExtCPTabButtonItemBase, ICPTabButtonItemClosableOnSelect {
    readonly type: CPTabButtonItemType.Event;
    readonly event: IExtEvent;
}
export interface IExtCPTabButtonItemWithItems extends IExtCPTabButtonItemBase, IExtCPTabButtonItemsDelegate {
    readonly type: CPTabButtonItemType.Items;
}
export interface IExtCPTabButtonItemWithInfoIcon extends IExtCPTabButtonItemBase, ICPTabButtonItemClosableOnSelect {
    readonly type: CPTabButtonItemType.InfoIcon;
    readonly event: IExtEvent;
    readonly infoIconContent: string;
}
export interface IExtCPTabButtonItemWithInfoText extends IExtCPTabButtonItemBase, ICPTabButtonItemClosableOnSelect {
    readonly type: CPTabButtonItemType.InfoText;
    readonly event: IExtEvent;
    readonly infoText: string;
}
export interface IExtCPTabButtonItemWithPopup extends IExtCPTabButtonItemBase {
    readonly type: CPTabButtonItemType.Popup;
    readonly popup: IExtPopup;
}
export type IExtCPTabButtonItem = IExtCPTabButtonItemWithEvent | IExtCPTabButtonItemWithItems | IExtCPTabButtonItemWithInfoIcon | IExtCPTabButtonItemWithInfoText | IExtCPTabButtonItemWithPopup;
export type ICPTabButtonItem = IIntCPTabButtonItem | IExtCPTabButtonItem;
export type ICPTabButtonItemWithItems = IIntCPTabButtonItemWithItems | IExtCPTabButtonItemWithItems;
export {};
