import { TrackingTag } from '../interfaces/i_tracking_tag';
import { IExtEvent } from '../interfaces/i_ext_event';
import { IPopupInfo } from '../interfaces/i_popup_info';
export declare enum CPTabButtonItemInfoType {
    Event = "event",
    Items = "items",
    InfoIcon = "infoIcon",
    InfoText = "infoText",
    Popup = "popup"
}
export interface ICPTabButtonItemInfoBase {
    readonly tag: TrackingTag;
    readonly type: CPTabButtonItemInfoType;
    readonly title: string;
    readonly iconPath?: string;
    readonly isSelected?: boolean;
    readonly isDisabled?: boolean;
}
export interface ICPTabButtonItemClosableOnSelectInfo {
    readonly shouldCloseOnSelect?: boolean;
}
export interface ICPTabButtonItemWithEventInfo extends ICPTabButtonItemInfoBase, ICPTabButtonItemClosableOnSelectInfo {
    readonly type: CPTabButtonItemInfoType.Event;
    readonly event: IExtEvent;
}
export interface ICPTabButtonItemWithItemsInfo extends ICPTabButtonItemInfoBase {
    readonly type: CPTabButtonItemInfoType.Items;
    readonly itemsInfo: ICPTabButtonItemInfo[];
}
export interface ICPTabButtonItemWithInfoIconInfo extends ICPTabButtonItemInfoBase, ICPTabButtonItemClosableOnSelectInfo {
    readonly type: CPTabButtonItemInfoType.InfoIcon;
    readonly event: IExtEvent;
    readonly infoIconPath: string;
}
export interface ICPTabButtonItemWithInfoTextInfo extends ICPTabButtonItemInfoBase, ICPTabButtonItemClosableOnSelectInfo {
    readonly type: CPTabButtonItemInfoType.InfoText;
    readonly event: IExtEvent;
    readonly infoText: string;
}
export interface ICPTabButtonItemWithPopupInfo extends ICPTabButtonItemInfoBase {
    readonly type: CPTabButtonItemInfoType.Popup;
    readonly popupInfo: IPopupInfo;
}
export type ICPTabButtonItemInfo = ICPTabButtonItemWithEventInfo | ICPTabButtonItemWithItemsInfo | ICPTabButtonItemWithInfoIconInfo | ICPTabButtonItemWithInfoTextInfo | ICPTabButtonItemWithPopupInfo;
