import { CPTabButtonItemId, ICPTabButtonItem, IExtCPTabButtonItem, IIntCPTabButtonItem } from '../interfaces/i_cp_tab_button_item';
import { IDestructable } from '../interfaces/i_destructable';
import { IResettable } from '../interfaces/i_resettable';
export interface ICPTabButtonItemsDelegate extends IDestructable, IResettable {
    addItems(...items: ICPTabButtonItem[]): Promise<void>;
    insertItems(items: ICPTabButtonItem[], args: {
        atIndex: number;
    }): Promise<void>;
    hasItem(id: CPTabButtonItemId): boolean;
    getItemIndex(id: CPTabButtonItemId): number;
    getItem(id: CPTabButtonItemId): ICPTabButtonItem | undefined;
    getItemIds(): CPTabButtonItemId[];
    replaceItems(items: Map<CPTabButtonItemId, ICPTabButtonItem>): Promise<void>;
    replaceItemsInPlace(...items: ICPTabButtonItem[]): Promise<void>;
    removeItems(...ids: CPTabButtonItemId[]): Promise<void>;
    setItems(...items: ICPTabButtonItem[]): Promise<void>;
}
export interface IIntCPTabButtonItemsDelegate extends ICPTabButtonItemsDelegate {
    addItems(...items: IIntCPTabButtonItem[]): Promise<void>;
    insertItems(items: IIntCPTabButtonItem[], args: {
        atIndex: number;
    }): Promise<void>;
    hasItem(id: CPTabButtonItemId): boolean;
    getItemIndex(id: CPTabButtonItemId): number;
    getItem(id: CPTabButtonItemId): IIntCPTabButtonItem | undefined;
    getItemIds(): CPTabButtonItemId[];
    replaceItems(items: Map<CPTabButtonItemId, IIntCPTabButtonItem>): Promise<void>;
    replaceItemsInPlace(...items: IIntCPTabButtonItem[]): Promise<void>;
    removeItems(...ids: CPTabButtonItemId[]): Promise<void>;
    setItems(...items: IIntCPTabButtonItem[]): Promise<void>;
}
export interface IExtCPTabButtonItemsDelegate extends ICPTabButtonItemsDelegate {
    addItems(...items: IExtCPTabButtonItem[]): Promise<void>;
    insertItems(items: IExtCPTabButtonItem[], args: {
        atIndex: number;
    }): Promise<void>;
    hasItem(id: CPTabButtonItemId): boolean;
    getItemIndex(id: CPTabButtonItemId): number;
    getItem(id: CPTabButtonItemId): IExtCPTabButtonItem | undefined;
    getItemIds(): CPTabButtonItemId[];
    replaceItems(items: Map<CPTabButtonItemId, IExtCPTabButtonItem>): Promise<void>;
    replaceItemsInPlace(...items: IExtCPTabButtonItem[]): Promise<void>;
    removeItems(...ids: CPTabButtonItemId[]): Promise<void>;
    setItems(...items: IExtCPTabButtonItem[]): Promise<void>;
}
