import { CPTabButtonId, ICPTabButton, IExtCPTabButton, IIntCPTabButton } from '../interfaces/i_cp_tab_button';
import { IDestructable } from '../interfaces/i_destructable';
import { IResettable } from '../interfaces/i_resettable';
export interface ICPTabButtonsDelegate extends IDestructable, IResettable {
    addButtons(...buttons: ICPTabButton[]): Promise<void>;
    insertButtons(buttons: ICPTabButton[], args: {
        atIndex: number;
    }): Promise<void>;
    hasButton(id: CPTabButtonId): boolean;
    getButtonIndex(id: CPTabButtonId): number;
    getButton(id: CPTabButtonId): ICPTabButton | undefined;
    getButtonIds(): CPTabButtonId[];
    replaceButtons(buttons: Map<CPTabButtonId, ICPTabButton>): Promise<void>;
    replaceButtonsInPlace(...buttons: ICPTabButton[]): Promise<void>;
    removeButtons(...ids: CPTabButtonId[]): Promise<void>;
    setButtons(...buttons: ICPTabButton[]): Promise<void>;
}
export interface IIntCPTabButtonsDelegate extends ICPTabButtonsDelegate {
    addButtons(...buttons: IIntCPTabButton[]): Promise<void>;
    insertButtons(buttons: IIntCPTabButton[], args: {
        atIndex: number;
    }): Promise<void>;
    hasButton(id: CPTabButtonId): boolean;
    getButtonIndex(id: CPTabButtonId): number;
    getButton(id: CPTabButtonId): IIntCPTabButton | undefined;
    getButtonIds(): CPTabButtonId[];
    replaceButtons(buttons: Map<CPTabButtonId, IIntCPTabButton>): Promise<void>;
    replaceButtonsInPlace(...buttons: IIntCPTabButton[]): Promise<void>;
    removeButtons(...ids: CPTabButtonId[]): Promise<void>;
    setButtons(...buttons: IIntCPTabButton[]): Promise<void>;
}
export interface IExtCPTabButtonsDelegate extends ICPTabButtonsDelegate {
    addButtons(...buttons: IExtCPTabButton[]): Promise<void>;
    insertButtons(buttons: IExtCPTabButton[], args: {
        atIndex: number;
    }): Promise<void>;
    hasButton(id: CPTabButtonId): boolean;
    getButtonIndex(id: CPTabButtonId): number;
    getButton(id: CPTabButtonId): IExtCPTabButton | undefined;
    getButtonIds(): CPTabButtonId[];
    replaceButtons(buttons: Map<CPTabButtonId, IExtCPTabButton>): Promise<void>;
    replaceButtonsInPlace(...buttons: IExtCPTabButton[]): Promise<void>;
    removeButtons(...ids: CPTabButtonId[]): Promise<void>;
    setButtons(...buttons: IExtCPTabButton[]): Promise<void>;
}
