import { TrackingTag } from '../interfaces/i_tracking_tag';
import { ICPTabButtonInfo } from '../interfaces/i_cp_tab_button_info';
import { ICPTabSectionInfo } from '../interfaces/i_cp_tab_section_info';
export declare enum CPTabInfoType {
    Html = "html",
    Sections = "sections"
}
export interface ICPTabInfoBase {
    readonly tag: TrackingTag;
    readonly type: CPTabInfoType;
    readonly title: string;
    readonly iconPath?: string;
    readonly buttonsInfo?: ICPTabButtonInfo[];
}
export interface ICPTabWithHtmlInfo extends ICPTabInfoBase {
    readonly type: CPTabInfoType.Html;
    readonly htmlPath: string;
    readonly nodeScriptPath?: string;
    readonly initData?: any;
}
export interface ICPTabWithSectionsInfo extends ICPTabInfoBase {
    readonly type: CPTabInfoType.Sections;
    readonly sectionsInfo: ICPTabSectionInfo[];
    readonly scriptPath?: string;
    readonly nodeScriptPath?: string;
    readonly initData?: any;
}
export type ICPTabInfo = ICPTabWithHtmlInfo | ICPTabWithSectionsInfo;
