import { EntityType } from '../interfaces/i_entity';
import { IPathAndUrl } from '../interfaces/i_path_and_url';
import { CPTabId } from '../interfaces/i_cp_tab';
import { IExtCPTabButtonsDelegate, IIntCPTabButtonsDelegate } from '../interfaces/i_cp_tab_buttons_delegate';
import { IWebviewDelegate } from '../interfaces/i_webview_delegate';
import { IEntityLifecycle } from '../interfaces/i_entity_lifecycle';
import { IExtEntity } from '../interfaces/i_ext_entity';
import { IDestructable } from '../interfaces/i_destructable';
import { IResettable } from '../interfaces/i_resettable';
export type CPTabSectionId = string;
export interface ICPTabSectionBase extends IDestructable, IResettable, IEntityLifecycle {
    readonly entityType: EntityType;
    readonly id: CPTabSectionId;
    readonly title: string;
    readonly iconContent?: string;
    readonly parentTabId: CPTabId;
    readonly isDefault: boolean;
    readonly createdDate: Date;
}
export declare enum IntCPTabSectionType {
}
export interface IIntCPTabSectionBase extends ICPTabSectionBase, IIntCPTabButtonsDelegate {
    readonly entityType: EntityType.Int;
    readonly type: IntCPTabSectionType;
}
export type IIntCPTabSection = IIntCPTabSectionBase;
export declare enum ExtCPTabSectionType {
    Html = "html"
}
export interface IExtCPTabSectionBase extends ICPTabSectionBase, IExtEntity, IExtCPTabButtonsDelegate {
    readonly entityType: EntityType.Ext;
    readonly type: ExtCPTabSectionType;
}
export interface IExtCPTabSectionWithHtml extends IExtCPTabSectionBase, IWebviewDelegate {
    readonly type: ExtCPTabSectionType.Html;
    readonly htmlPathAndUrl: IPathAndUrl;
    readonly nodeScriptPath?: string;
    readonly initData?: any;
}
export type IExtCPTabSection = IExtCPTabSectionWithHtml;
export type ICPTabSection = IIntCPTabSection | IExtCPTabSection;
