import { CPTabSectionId, ICPTabSection, IExtCPTabSection, IIntCPTabSection } from '../interfaces/i_cp_tab_section';
import { IDestructable } from '../interfaces/i_destructable';
import { IResettable } from '../interfaces/i_resettable';
export interface ICPTabSectionsDelegate extends IDestructable, IResettable {
    addSections(...sections: ICPTabSection[]): Promise<void>;
    insertSections(sections: ICPTabSection[], args: {
        atIndex: number;
    }): Promise<void>;
    hasSection(id: CPTabSectionId): boolean;
    getSectionIndex(id: CPTabSectionId): number;
    getSection(id: CPTabSectionId): ICPTabSection | undefined;
    getSectionIds(): CPTabSectionId[];
    replaceSections(sections: Map<CPTabSectionId, ICPTabSection>): Promise<void>;
    replaceSectionsInPlace(...sections: ICPTabSection[]): Promise<void>;
    removeSections(...ids: CPTabSectionId[]): Promise<void>;
    setSections(...sections: ICPTabSection[]): Promise<void>;
    getDefaultSectionId(): CPTabSectionId;
}
export interface IIntCPTabSectionsDelegate extends ICPTabSectionsDelegate {
    addSections(...sections: IIntCPTabSection[]): Promise<void>;
    insertSections(sections: IIntCPTabSection[], args: {
        atIndex: number;
    }): Promise<void>;
    hasSection(id: CPTabSectionId): boolean;
    getSectionIndex(id: CPTabSectionId): number;
    getSection(id: CPTabSectionId): IIntCPTabSection | undefined;
    getSectionIds(): CPTabSectionId[];
    replaceSections(sections: Map<CPTabSectionId, IIntCPTabSection>): Promise<void>;
    replaceSectionsInPlace(...sections: IIntCPTabSection[]): Promise<void>;
    removeSections(...ids: CPTabSectionId[]): Promise<void>;
    setSections(...sections: IIntCPTabSection[]): Promise<void>;
    getDefaultSectionId(): CPTabSectionId;
}
export interface IExtCPTabSectionsDelegate extends ICPTabSectionsDelegate {
    addSections(...sections: IExtCPTabSection[]): Promise<void>;
    insertSections(sections: IExtCPTabSection[], args: {
        atIndex: number;
    }): Promise<void>;
    hasSection(id: CPTabSectionId): boolean;
    getSectionIndex(id: CPTabSectionId): number;
    getSection(id: CPTabSectionId): IExtCPTabSection | undefined;
    getSectionIds(): CPTabSectionId[];
    replaceSections(sections: Map<CPTabSectionId, IExtCPTabSection>): Promise<void>;
    replaceSectionsInPlace(...sections: IExtCPTabSection[]): Promise<void>;
    removeSections(...ids: CPTabSectionId[]): Promise<void>;
    setSections(...sections: IExtCPTabSection[]): Promise<void>;
    getDefaultSectionId(): CPTabSectionId;
}
