import { TrackingTag } from '../interfaces/i_tracking_tag';
import { ICPTabInfo } from '../interfaces/i_cp_tab_info';
import { ICPTabSectionInfo } from '../interfaces/i_cp_tab_section_info';
import { ICPTabButtonInfo } from '../interfaces/i_cp_tab_button_info';
import { ICPTabButtonItemInfo } from '../interfaces/i_cp_tab_button_item_info';
import { CPTabSectionId } from '../interfaces/i_cp_tab_section';
import { CPTabId } from '../interfaces/i_cp_tab';
import { CPTabButtonId } from '../interfaces/i_cp_tab_button';
import { CPTabButtonItemId } from '../interfaces/i_cp_tab_button_item';
export interface IExtCPTagsController {
    hasTag(tag: TrackingTag): boolean;
    getTabId(tabTag: TrackingTag): CPTabId;
    getTabSectionId(sectionTag: TrackingTag): CPTabSectionId;
    getTabOrSectionId(tabOrSectionTag: TrackingTag): CPTabId | CPTabSectionId;
    getTabButtonId(buttonTag: TrackingTag): CPTabButtonId;
    getTabButtonItemId(itemTag: TrackingTag): CPTabButtonItemId;
    getTabButtonOrItemId(buttonOrItemTag: TrackingTag): CPTabButtonId | CPTabButtonItemId;
    getTabTags(): TrackingTag[];
    getTabSectionTags(tabTag: TrackingTag): TrackingTag[];
    getTabButtonTags(tabOrSectionTag: TrackingTag): TrackingTag[];
    getTabButtonItemTags(buttonOrItemTag: TrackingTag): TrackingTag[];
    getTags(): TrackingTag[];
    addTabTags(args: {
        tabsInfo: ICPTabInfo[];
    }): void;
    addTabSectionTags(args: {
        tabTag: TrackingTag;
        sectionsInfo: ICPTabSectionInfo[];
    }): void;
    addTabButtonTags(args: {
        tabOrSectionTag: TrackingTag;
        buttonsInfo: ICPTabButtonInfo[];
    }): void;
    addTabButtonItemTags(args: {
        buttonOrItemTag: TrackingTag;
        itemsInfo: ICPTabButtonItemInfo[];
    }): void;
    insertTabTags(args: {
        tabsInfo: ICPTabInfo[];
        atIndex: number;
    }): void;
    insertTabSectionTags(args: {
        tabTag: TrackingTag;
        sectionsInfo: ICPTabSectionInfo[];
        atIndex: number;
    }): void;
    insertTabButtonTags(args: {
        tabOrSectionTag: TrackingTag;
        buttonsInfo: ICPTabButtonInfo[];
        atIndex: number;
    }): void;
    insertTabButtonItemTags(args: {
        buttonOrItemTag: TrackingTag;
        itemsInfo: ICPTabButtonItemInfo[];
        atIndex: number;
    }): void;
    removeTabTags(...tabTags: TrackingTag[]): void;
    removeTabSectionTags(...sectionTags: TrackingTag[]): void;
    removeTabButtonTags(...buttonTags: TrackingTag[]): void;
    removeTabButtonItemTags(...itemTags: TrackingTag[]): void;
    replaceTabTags(args: {
        tabsInfo: Map<TrackingTag, ICPTabInfo>;
        oldTabIndexes: Map<TrackingTag, number>;
    }): void;
    replaceTabSectionTags(args: {
        sectionsInfo: Map<TrackingTag, ICPTabSectionInfo>;
        oldSectionIndexes: Map<TrackingTag, number>;
    }): void;
    replaceTabButtonTags(args: {
        buttonsInfo: Map<TrackingTag, ICPTabButtonInfo>;
        oldButtonIndexes: Map<TrackingTag, number>;
    }): void;
    replaceTabButtonItemTags(args: {
        itemsInfo: Map<TrackingTag, ICPTabButtonItemInfo>;
        oldItemIndexes: Map<TrackingTag, number>;
    }): void;
    updateTabTags(args: {
        tabsInfo: ICPTabInfo[];
    }): void;
    updateTabSectionTags(args: {
        tabTag: TrackingTag;
        sectionsInfo: ICPTabSectionInfo[];
    }): void;
    updateTabButtonTags(args: {
        tabOrSectionTag: TrackingTag;
        buttonsInfo: ICPTabButtonInfo[];
    }): void;
    updateTabButtonItemTags(args: {
        buttonOrItemTag: TrackingTag;
        itemsInfo: ICPTabButtonItemInfo[];
    }): void;
    clear(): void;
}
