import { TrackingTag } from '../interfaces/i_tracking_tag';
import { MPTabId } from '../interfaces/i_mp_tab';
import { IMPTabInfo } from '../interfaces/i_mp_tab_info';
export interface IExtMPTagsController {
    hasTag(tag: TrackingTag): boolean;
    getTabId(tabTag: TrackingTag): MPTabId;
    getTabTags(): TrackingTag[];
    getTags(): TrackingTag[];
    addTabTags(args: {
        tabsInfo: IMPTabInfo[];
    }): void;
    insertTabTags(args: {
        tabsInfo: IMPTabInfo[];
        atIndex: number;
    }): void;
    removeTabTags(...tabTags: TrackingTag[]): void;
    replaceTabTags(args: {
        tabsInfo: Map<TrackingTag, IMPTabInfo>;
        oldTabIndexes: Map<TrackingTag, number>;
    }): void;
    updateTabTags(args: {
        tabsInfo: IMPTabInfo[];
    }): void;
    clear(): void;
}
