import { ExtensionId, ExtensionState } from '../interfaces/i_extension';
import { IExtensionPackageInfo } from '../interfaces/i_extension_package_info';
export interface IExtensionInfoRaw {
    readonly id: ExtensionId;
    readonly packageInfo: IExtensionPackageInfo;
    readonly filePath: string;
    readonly iconContent?: string;
    readonly state: ExtensionState;
    readonly isDebug: boolean;
}
export interface IExtensionInfo {
    readonly id: ExtensionId;
    readonly packageInfo: IExtensionPackageInfo;
    readonly filePath: string;
    readonly iconContent?: string;
    readonly isDebug: boolean;
    getState(): ExtensionState;
    isAvailable(): boolean;
    isInstalling(): boolean;
    isInvalid(): boolean;
    canBeInstalled(): boolean;
}
export interface IExtensionInfoInvalid {
    readonly fileName: string;
    readonly filePath: string;
    readonly isDebug: boolean;
}
