import { ImplementableApi, RequirableApi } from '../interfaces/i_api';
import { INodePackageInfoEngines } from '../interfaces/i_node_package_info';
import { ISemver } from '../interfaces/i_semver';
export type ExtensionRequirableApisRaw = RequirableApi[];
export type ExtensionImplementableApisRaw = ImplementableApi[];
export type ExtensionRequirableApis = Set<RequirableApi>;
export type ExtensionImplementableApis = Set<ImplementableApi>;
export interface IExtensionPackageInfoRaw {
    readonly id: string;
    readonly title: string;
    readonly description: string;
    readonly author: string;
    readonly version: string;
    readonly engines: INodePackageInfoEngines;
    readonly url?: string;
    readonly license?: string;
    readonly iconPath?: string;
    readonly scriptPath: string;
    readonly nodeScriptPath?: string;
    readonly requiredApis?: ExtensionRequirableApisRaw;
    readonly implementedApis?: ExtensionImplementableApisRaw;
}
export interface IExtensionPackageInfo {
    readonly id: string;
    readonly title: string;
    readonly description: string;
    readonly author: string;
    readonly version: ISemver;
    readonly apiVersion: ISemver;
    readonly url?: string;
    readonly license?: string;
    readonly iconPath?: string;
    readonly scriptPath: string;
    readonly nodeScriptPath?: string;
    readonly requiredApis: ExtensionRequirableApis;
    readonly implementedApis?: ExtensionImplementableApis;
}
