import { Api } from '../interfaces/i_api';
import { ApiInfoType } from '../interfaces/i_api_info';
export declare namespace lifecycleApiInfo {
    const api = Api.Lifecycle;
    const apiInfoType = ApiInfoType.Main;
    enum Channel {
        OnReady = "lifecycleApi.onReady",
        OnDestroy = "lifecycleApi.onDestroy",
        OnDidGoBackground = "lifecycleApi.onDidGoBackground",
        OnDidGoForeground = "lifecycleApi.onDidGoForeground"
    }
    namespace onReady {
        const channel = Channel.OnReady;
        namespace listener {
            type ArgsType = [initData?: any];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type ArgsType = [listener: ListenerType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onDestroy {
        const channel = Channel.OnDestroy;
        namespace listener {
            type ArgsType = [];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type ArgsType = [listener: ListenerType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onDidGoBackground {
        const channel = Channel.OnDidGoBackground;
        namespace listener {
            type ArgsType = [];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace onDidGoForeground {
        const channel = Channel.OnDidGoForeground;
        namespace listener {
            type ArgsType = [];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
}
