import { ApiInfoType } from '../interfaces/i_api_info';
import { lifecycleApiInfo as i } from '../interfaces/i_lifecycle_api_info';
import { lifecycleApiInfoPreload as iPre } from '../interfaces/i_lifecycle_api_info_preload';
import { IpcRendererEvent } from '../classes/electron';
export declare namespace lifecycleApiInfoInternal {
    const api = Api.Lifecycle;
    const apiInfoType = ApiInfoType.Internal;
    namespace sendReady {
        const channel = i.Channel.OnReady;
        type ArgsType = iPre.onReady.requestListener.EventArgsType;
        type ResultType = i.onReady.listener.ResultType;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace sendDestroy {
        const channel = i.Channel.OnDestroy;
        type ArgsType = iPre.onDestroy.requestListener.EventArgsType;
        type ResultType = i.onDestroy.listener.ResultType;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace sendDidGoBackground {
        const channel = i.Channel.OnDidGoBackground;
        type ArgsType = iPre.onDidGoBackground.requestListener.EventArgsType;
        type ResultType = i.onDidGoBackground.listener.ResultType;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace sendDidGoForeground {
        const channel = i.Channel.OnDidGoForeground;
        type ArgsType = iPre.onDidGoForeground.requestListener.EventArgsType;
        type ResultType = i.onDidGoForeground.listener.ResultType;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
}
