import { IpcRendererEvent } from '../classes/electron';
import { ApiListenerId } from '../interfaces/i_api_listener';
import { lifecycleApiInfo as i } from '../interfaces/i_lifecycle_api_info';
import { ApiInfoType } from '../interfaces/i_api_info';
export declare namespace lifecycleApiInfoPreload {
    const api = Api.Lifecycle;
    const apiInfoType = ApiInfoType.Preload;
    namespace onReady {
        const channel = i.Channel.OnReady;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onReady.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onReady.ListenerType;
        type ArgsType = [listener: ListenerType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onDestroy {
        const channel = i.Channel.OnDestroy;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onDestroy.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onDestroy.ListenerType;
        type ArgsType = [listener: ListenerType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onDidGoBackground {
        const channel = i.Channel.OnDidGoBackground;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onDidGoBackground.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onDidGoBackground.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace onDidGoForeground {
        const channel = i.Channel.OnDidGoForeground;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onDidGoForeground.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onDidGoForeground.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
}
