import { Api } from '../interfaces/i_api';
import { TrackingTag } from '../interfaces/i_tracking_tag';
import { ApiInfoType } from '../interfaces/i_api_info';
import { IMPTabInfo } from '../interfaces/i_mp_tab_info';
export declare namespace mainPanelApiInfo {
    const api = Api.MainPanel;
    const apiInfoType = ApiInfoType.Main;
    enum Channel {
        SetTabs = "mainPanelApi.setTabs",
        OnTabsSet = "mainPanelApi.onTabsSet",
        AddTabs = "mainPanelApi.addTabs",
        OnTabsAdded = "mainPanelApi.onTabsAdded",
        InsertTabs = "mainPanelApi.insertTabs",
        OnTabsInserted = "mainPanelApi.onTabsInserted",
        HasTab = "mainPanelApi.hasTab",
        GetTabTags = "mainPanelApi.getTabTags",
        ReplaceTabs = "mainPanelApi.replaceTabs",
        OnTabsReplaced = "mainPanelApi.onTabsReplaced",
        RemoveTabs = "mainPanelApi.removeTabs",
        OnTabsRemoved = "mainPanelApi.onTabsRemoved",
        SelectTab = "mainPanelApi.selectTab",
        GetSelectedTabTag = "mainPanelApi.getSelectedTabTag",
        GetSelectedTabIndex = "mainPanelApi.getSelectedTabIndex",
        GetTabIndex = "mainPanelApi.getTabIndex"
    }
    namespace setTabs {
        const channel = Channel.SetTabs;
        type InnerArgsType = {
            isSelected?: boolean;
            selectTabTag?: TrackingTag;
        } | undefined;
        type ArgsType = [tabsInfo: IMPTabInfo[], args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabsSet {
        const channel = Channel.OnTabsSet;
        namespace listener {
            type ArgsType = [
                tabTags: TrackingTag[],
                args: setTabs.InnerArgsType
            ];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace addTabs {
        const channel = Channel.AddTabs;
        type InnerArgsType = {
            isSelected?: boolean;
            selectTabTag?: TrackingTag;
        } | undefined;
        type ArgsType = [tabsInfo: IMPTabInfo[], args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabsAdded {
        const channel = Channel.OnTabsAdded;
        namespace listener {
            type ArgsType = [
                tabTags: TrackingTag[],
                args: addTabs.InnerArgsType
            ];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace insertTabs {
        const channel = Channel.InsertTabs;
        type InnerArgsType = {
            atIndex: number;
            isSelected?: boolean;
            selectTabTag?: TrackingTag;
        };
        type ArgsType = [tabsInfo: IMPTabInfo[], args: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabsInserted {
        const channel = Channel.OnTabsInserted;
        namespace listener {
            type ArgsType = [
                tabTags: TrackingTag[],
                args: insertTabs.InnerArgsType
            ];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace hasTab {
        const channel = Channel.HasTab;
        type ArgsType = [tag: TrackingTag];
        type ResultType = boolean;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace getTabTags {
        const channel = Channel.GetTabTags;
        type ArgsType = [];
        type ResultType = TrackingTag[];
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace replaceTabs {
        const channel = Channel.ReplaceTabs;
        type ArgsType = [tabsInfo: Map<TrackingTag, IMPTabInfo>];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabsReplaced {
        const channel = Channel.OnTabsReplaced;
        namespace listener {
            type ArgsType = [tabTags: Map<TrackingTag, TrackingTag>];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace removeTabs {
        const channel = Channel.RemoveTabs;
        type ArgsType = [...tags: TrackingTag[]];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onTabsRemoved {
        const channel = Channel.OnTabsRemoved;
        namespace listener {
            type ArgsType = [...tags: TrackingTag[]];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace selectTab {
        const channel = Channel.SelectTab;
        type ArgsType = [tag: TrackingTag];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace getSelectedTabTag {
        const channel = Channel.GetSelectedTabTag;
        type ArgsType = [];
        type ResultType = TrackingTag | undefined;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace getSelectedTabIndex {
        const channel = Channel.GetSelectedTabIndex;
        type ArgsType = [];
        type ResultType = number | undefined;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace getTabIndex {
        const channel = Channel.GetTabIndex;
        type ArgsType = [tag: TrackingTag];
        type ResultType = number | undefined;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
}
