import { IpcRendererEvent } from '../classes/electron';
import { mainPanelApiInfo as i } from '../interfaces/i_main_panel_api_info';
import { ApiInfoType } from '../interfaces/i_api_info';
import { ApiListenerId } from '../interfaces/i_api_listener';
export declare namespace mainPanelApiInfoPreload {
    const api = Api.MainPanel;
    const apiInfoType = ApiInfoType.Preload;
    namespace setTabs {
        const channel = i.Channel.SetTabs;
        type ArgsType = i.setTabs.ArgsType;
        type ResultType = i.setTabs.ResultType;
        type ReturnType = i.setTabs.ReturnType;
        type FunctionType = i.setTabs.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabsSet {
        const channel = i.Channel.OnTabsSet;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabsSet.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabsSet.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace addTabs {
        const channel = i.Channel.AddTabs;
        type ArgsType = i.addTabs.ArgsType;
        type ResultType = i.addTabs.ResultType;
        type ReturnType = i.addTabs.ReturnType;
        type FunctionType = i.addTabs.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabsAdded {
        const channel = i.Channel.OnTabsAdded;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabsAdded.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabsAdded.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace insertTabs {
        const channel = i.Channel.InsertTabs;
        type ArgsType = i.insertTabs.ArgsType;
        type ResultType = i.insertTabs.ResultType;
        type ReturnType = i.insertTabs.ReturnType;
        type FunctionType = i.insertTabs.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabsInserted {
        const channel = i.Channel.OnTabsInserted;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabsInserted.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabsInserted.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace hasTab {
        const channel = i.Channel.HasTab;
        type ArgsType = i.hasTab.ArgsType;
        type ResultType = i.hasTab.ResultType;
        type ReturnType = i.hasTab.ReturnType;
        type FunctionType = i.hasTab.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [hasTab: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace getTabTags {
        const channel = i.Channel.GetTabTags;
        type ArgsType = i.getTabTags.ArgsType;
        type ResultType = i.getTabTags.ResultType;
        type ReturnType = i.getTabTags.ReturnType;
        type FunctionType = i.getTabTags.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [tabTags: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace replaceTabs {
        const channel = i.Channel.ReplaceTabs;
        type ArgsType = i.replaceTabs.ArgsType;
        type ResultType = i.replaceTabs.ResultType;
        type ReturnType = i.replaceTabs.ReturnType;
        type FunctionType = i.replaceTabs.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabsReplaced {
        const channel = i.Channel.OnTabsReplaced;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabsReplaced.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabsReplaced.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace removeTabs {
        const channel = i.Channel.RemoveTabs;
        type ArgsType = i.removeTabs.ArgsType;
        type ResultType = i.removeTabs.ResultType;
        type ReturnType = i.removeTabs.ReturnType;
        type FunctionType = i.removeTabs.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onTabsRemoved {
        const channel = i.Channel.OnTabsRemoved;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onTabsRemoved.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onTabsRemoved.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace selectTab {
        const channel = i.Channel.SelectTab;
        type ArgsType = i.selectTab.ArgsType;
        type ResultType = i.selectTab.ResultType;
        type ReturnType = i.selectTab.ReturnType;
        type FunctionType = i.selectTab.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace getSelectedTabTag {
        const channel = i.Channel.GetSelectedTabTag;
        type ArgsType = i.getSelectedTabTag.ArgsType;
        type ResultType = i.getSelectedTabTag.ResultType;
        type ReturnType = i.getSelectedTabTag.ReturnType;
        type FunctionType = i.getSelectedTabTag.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [selectedTabInfo: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace getSelectedTabIndex {
        const channel = i.Channel.GetSelectedTabIndex;
        type ArgsType = i.getSelectedTabIndex.ArgsType;
        type ResultType = i.getSelectedTabIndex.ResultType;
        type ReturnType = i.getSelectedTabIndex.ReturnType;
        type FunctionType = i.getSelectedTabIndex.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [selectedTabInfo: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace getTabIndex {
        const channel = i.Channel.GetTabIndex;
        type ArgsType = i.getTabIndex.ArgsType;
        type ResultType = i.getTabIndex.ResultType;
        type ReturnType = i.getTabIndex.ReturnType;
        type FunctionType = i.getTabIndex.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [tabIndex: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
}
