import { Api } from '../interfaces/i_api';
import { ApiInfoType } from '../interfaces/i_api_info';
import { TrackingTag } from '../interfaces/i_tracking_tag';
export declare namespace nodeApiInfo {
    const api = Api.Node;
    const apiInfoType = ApiInfoType.Main;
    enum Channel {
        SendData = "nodeApi.sendData",
        OnDataReceived = "nodeApi.onDataReceived",
        SendEvent = "nodeApi.sendEvent",
        OnEventReceived = "nodeApi.onEventReceived"
    }
    namespace sendData {
        const channel = Channel.SendData;
        type InnerArgsType = {
            toTags?: TrackingTag[];
            channel?: string;
        } | undefined;
        type ArgsType = [data: any, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onDataReceived {
        const channel = Channel.OnDataReceived;
        namespace listener {
            type InnerArgsType = {
                fromTag: string;
                channel?: string;
            };
            type ArgsType = [data: any, args: InnerArgsType];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace sendEvent {
        const channel = Channel.SendEvent;
        type InnerArgsType = {
            toTags?: TrackingTag[];
            channel?: string;
            data?: any;
        } | undefined;
        type ArgsType = [event: string, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onEventReceived {
        const channel = Channel.OnEventReceived;
        namespace listener {
            type InnerArgsType = {
                fromTag: string;
                channel?: string;
                data?: any;
            };
            type ArgsType = [event: string, args: InnerArgsType];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
}
