import { ApiInfoType } from '../interfaces/i_api_info';
import { nodeApiInfo as i } from '../interfaces/i_node_api_info';
import { nodeApiInfoPreload as iPre } from '../interfaces/i_node_api_info_preload';
import { IpcRendererEvent } from '../classes/electron';
export declare namespace nodeApiInfoInternal {
    const api = Api.Node;
    const apiInfoType = ApiInfoType.Internal;
    namespace sendData {
        const channel = i.Channel.OnDataReceived;
        type ArgsType = iPre.onDataReceived.requestListener.EventArgsType;
        type ResultType = i.onDataReceived.listener.ResultType;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace sendEvent {
        const channel = i.Channel.OnEventReceived;
        type ArgsType = iPre.onEventReceived.requestListener.EventArgsType;
        type ResultType = i.onEventReceived.listener.ResultType;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
}
