import { ApiListenerId } from '../interfaces/i_api_listener';
import { IpcRendererEvent } from '../classes/electron';
import { nodeApiInfo as i } from '../interfaces/i_node_api_info';
import { ApiInfoType } from '../interfaces/i_api_info';
export declare namespace nodeApiInfoPreload {
    const api = Api.Node;
    const apiInfoType = ApiInfoType.Preload;
    namespace sendData {
        const channel = i.Channel.SendData;
        type ArgsType = i.sendData.ArgsType;
        type ResultType = i.sendData.ResultType;
        type ReturnType = i.sendData.ReturnType;
        type FunctionType = i.sendData.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onDataReceived {
        const channel = i.Channel.OnDataReceived;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onDataReceived.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onDataReceived.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace sendEvent {
        const channel = i.Channel.SendEvent;
        type ArgsType = i.sendEvent.ArgsType;
        type ResultType = i.sendEvent.ResultType;
        type ReturnType = i.sendEvent.ReturnType;
        type FunctionType = i.sendEvent.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onEventReceived {
        const channel = i.Channel.OnEventReceived;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onEventReceived.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onEventReceived.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
}
