import { Api } from '../interfaces/i_api';
import { ApiInfoType } from '../interfaces/i_api_info';
export declare namespace pingPongApiInfo {
    const api = Api.PingPong;
    const apiInfoType = ApiInfoType.Main;
    enum Channel {
        Ping = "pingPongApi.ping",
        OnPing = "pingPongApi.onPing",
        Pong = "pingPongApi.pong",
        OnPong = "pingPongApi.onPong"
    }
    namespace ping {
        const channel = Channel.Ping;
        type ArgsType = [];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onPing {
        const channel = Channel.OnPing;
        namespace listener {
            type ArgsType = [];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace pong {
        const channel = Channel.Pong;
        type ArgsType = [];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
    }
    namespace onPong {
        const channel = Channel.OnPong;
        namespace listener {
            type ArgsType = [];
            type ResultType = void;
            type ReturnType = ResultType | Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
        type ListenerType = listener.FunctionType;
        type InnerArgsType = {
            isOnce?: boolean;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ListenerType = listener.FunctionType | undefined;
            type ArgsType = [listener?: ListenerType];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
}
