import { IpcRendererEvent } from '../classes/electron';
import { ApiListenerId } from '../interfaces/i_api_listener';
import { pingPongApiInfo as i } from '../interfaces/i_ping_pong_api_info';
import { ApiInfoType } from '../interfaces/i_api_info';
export declare namespace pingPongApiInfoPreload {
    const api = Api.PingPong;
    const apiInfoType = ApiInfoType.Preload;
    namespace ping {
        const channel = i.Channel.Ping;
        type ArgsType = i.ping.ArgsType;
        type ResultType = i.ping.ResultType;
        type ReturnType = i.ping.ReturnType;
        type FunctionType = i.ping.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onPing {
        const channel = i.Channel.OnPing;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onPing.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onPing.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace pong {
        const channel = i.Channel.Pong;
        type ArgsType = i.pong.ArgsType;
        type ResultType = i.pong.ResultType;
        type ReturnType = i.pong.ReturnType;
        type FunctionType = i.pong.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onPong {
        const channel = i.Channel.OnPong;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onPong.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onPong.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
}
