import { EntityType } from '../interfaces/i_entity';
import { IPathAndUrl } from '../interfaces/i_path_and_url';
import { IEntityLifecycle } from '../interfaces/i_entity_lifecycle';
import { IExtEntity } from '../interfaces/i_ext_entity';
import { IWebviewDelegate } from '../interfaces/i_webview_delegate';
import { IDestructable } from '../interfaces/i_destructable';
import { IResettable } from '../interfaces/i_resettable';
export type PopupId = string;
export interface IPopupSize {
    width?: number;
    height?: number;
}
export interface IPopupBase extends IDestructable, IResettable, IEntityLifecycle {
    readonly entityType: EntityType;
    readonly id: PopupId;
    readonly size?: IPopupSize;
    readonly createdDate: Date;
}
export declare enum IntPopupType {
}
export interface IIntPopupBase extends IPopupBase {
    readonly entityType: EntityType.Int;
    readonly type: IntPopupType;
}
export type IIntPopup = IIntPopupBase;
export declare enum ExtPopupType {
    Html = "html"
}
export interface IExtPopupBase extends IPopupBase, IExtEntity {
    readonly entityType: EntityType.Ext;
    readonly type: ExtPopupType;
}
export interface IExtPopupWithHtml extends IExtPopupBase, IWebviewDelegate {
    readonly type: ExtPopupType.Html;
    readonly htmlPathAndUrl: IPathAndUrl;
    readonly nodeScriptPath?: string;
    readonly initData?: any;
}
export type IExtPopup = IExtPopupWithHtml;
export type IPopup = IIntPopup | IExtPopup;
