import { ApiListenerId } from '../interfaces/i_api_listener';
import { IpcRendererEvent } from '../classes/electron';
import { storageApiInfo as i } from '../interfaces/i_storage_api_info';
import { ApiInfoType } from '../interfaces/i_api_info';
export declare namespace storageApiInfoPreload {
    const api = Api.Storage;
    const apiInfoType = ApiInfoType.Preload;
    namespace has {
        const channel = i.Channel.Has;
        type ArgsType = i.has.ArgsType;
        type ResultType = i.has.ResultType;
        type ReturnType = i.has.ReturnType;
        type FunctionType = i.has.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [has: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace get {
        const channel = i.Channel.Get;
        type ArgsType = i.get.ArgsType;
        type ResultType = i.get.ResultType;
        type ReturnType = i.get.ReturnType;
        type FunctionType = i.get.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [value: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace set {
        const channel = i.Channel.Set;
        type ArgsType = i.set.ArgsType;
        type ResultType = i.set.ResultType;
        type ReturnType = i.set.ReturnType;
        type FunctionType = i.set.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onSet {
        const channel = i.Channel.OnSet;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onSet.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onSet.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace delete_ {
        const channel = i.Channel.Delete;
        type ArgsType = i.delete_.ArgsType;
        type ResultType = i.delete_.ResultType;
        type ReturnType = i.delete_.ReturnType;
        type FunctionType = i.delete_.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onDeleted {
        const channel = i.Channel.OnDeleted;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onDeleted.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onDeleted.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace getAll {
        const channel = i.Channel.GetAll;
        type ArgsType = i.getAll.ArgsType;
        type ResultType = i.getAll.ResultType;
        type ReturnType = i.getAll.ReturnType;
        type FunctionType = i.getAll.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [allRecords: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace clear {
        const channel = i.Channel.Clear;
        type ArgsType = i.clear.ArgsType;
        type ResultType = i.clear.ResultType;
        type ReturnType = i.clear.ReturnType;
        type FunctionType = i.clear.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace onCleared {
        const channel = i.Channel.OnCleared;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onCleared.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onCleared.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
    namespace onChangeed {
        const channel = i.Channel.OnChanged;
        namespace requestListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = i.onChangeed.listener.ArgsType;
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type RequestListenerType = requestListener.FunctionType;
        type ListenerType = i.onChangeed.ListenerType;
        type InnerArgsType = {
            listenerId?: ApiListenerId;
        } | undefined;
        type ArgsType = [listener: ListenerType, args?: InnerArgsType];
        type ResultType = void;
        type ReturnType = Promise<ResultType>;
        type FunctionType = (...args: ArgsType) => ReturnType;
        namespace unset {
            type ArgsType = [listenerId?: ApiListenerId];
            type ResultType = void;
            type ReturnType = Promise<ResultType>;
            type FunctionType = (...args: ArgsType) => ReturnType;
        }
    }
}
