import { IpcRendererEvent } from '../classes/electron';
import { tagsApiInfo as i } from '../interfaces/i_tags_api_info';
import { ApiInfoType } from '../interfaces/i_api_info';
export declare namespace tagsApiInfoPreload {
    const api = Api.Tags;
    const apiInfoType = ApiInfoType.Preload;
    namespace getTags {
        const channel = i.Channel.GetTags;
        type ArgsType = i.getTags.ArgsType;
        type ResultType = i.getTags.ResultType;
        type ReturnType = i.getTags.ReturnType;
        type FunctionType = i.getTags.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [tags: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
    namespace hasTag {
        const channel = i.Channel.HasTag;
        type ArgsType = i.hasTag.ArgsType;
        type ResultType = i.hasTag.ResultType;
        type ReturnType = i.hasTag.ReturnType;
        type FunctionType = i.hasTag.FunctionType;
        namespace responseListener {
            type EventType = IpcRendererEvent;
            type EventArgsType = [hasTag: ResultType];
            type ArgsType = [event: EventType, ...args: EventArgsType];
            type FunctionType = (...args: ArgsType) => void;
        }
        type ResponseListenerType = responseListener.FunctionType;
    }
}
