import { TrackingTag } from '../interfaces/i_tracking_tag';
export type UtilityProcessId = string;
export declare enum UtilityProcessEventName {
    Spawn = "spawn",
    Exit = "exit",
    Message = "message"
}
export declare enum UtilityProcessMessageType {
    Data = "data",
    Event = "event"
}
export declare enum UtilityProcessMessageDestination {
    Front = "front",
    Back = "back"
}
export type UtilityProcessSpawnListener = () => void;
export type UtilityProcessExitListener = () => void;
export type UtilityProcessMessageListener = (message: any) => void;
export interface IUtilityProcessDataMessageOut {
    readonly type: UtilityProcessMessageType.Data;
    readonly source: UtilityProcessMessageDestination;
    readonly data: any;
    readonly fromTag: TrackingTag;
    readonly channel?: string;
}
export interface IUtilityProcessEventMessageOut {
    readonly type: UtilityProcessMessageType.Event;
    readonly source: UtilityProcessMessageDestination;
    readonly event: string;
    readonly fromTag: TrackingTag;
    readonly channel?: string;
    readonly data?: any;
}
export interface IUtilityProcessFrontDataMessageIn {
    readonly type: UtilityProcessMessageType.Data;
    readonly destination: UtilityProcessMessageDestination.Front;
    readonly data: any;
    readonly toTags?: TrackingTag[];
    readonly channel?: string;
}
export interface IUtilityProcessFrontEventMessageIn {
    readonly type: UtilityProcessMessageType.Event;
    readonly destination: UtilityProcessMessageDestination.Front;
    readonly event: string;
    readonly toTags?: TrackingTag[];
    readonly channel?: string;
    readonly data?: any;
}
export interface IUtilityProcessBackDataMessageIn {
    readonly type: UtilityProcessMessageType.Data;
    readonly destination: UtilityProcessMessageDestination.Back;
    readonly data: any;
    readonly toTags: TrackingTag[];
    readonly channel?: string;
}
export interface IUtilityProcessBackEventMessageIn {
    readonly type: UtilityProcessMessageType.Event;
    readonly destination: UtilityProcessMessageDestination.Back;
    readonly event: string;
    readonly toTags: TrackingTag[];
    readonly channel?: string;
    readonly data?: any;
}
export type IUtilityProcessMessageOut = IUtilityProcessDataMessageOut | IUtilityProcessEventMessageOut;
export type IUtilityProcessFrontMessageIn = IUtilityProcessFrontDataMessageIn | IUtilityProcessFrontEventMessageIn;
export type IUtilityProcessBackMessageIn = IUtilityProcessBackDataMessageIn | IUtilityProcessBackEventMessageIn;
export type IUtilityProcessMessageIn = IUtilityProcessFrontMessageIn | IUtilityProcessBackMessageIn;
